# SourceRPG release 1.2.3 by Steven Hartin
# ./addons/eventscripts/sourcerpg/sourcerpg.py

# >>> To configure this addon please see srpg.cfg <<<
# >>> To configure the skills please see skills/skills.cfg <<<

#################################
#### DO NOT EDIT THIS FILE, #####
####    IF YOU DO, THINGS   #####
####   THINGS COULD BREAK   #####
#################################


# Import Modules
import es
import playerlib
import langlib
import gamethread
import os.path
import cPickle
import popuplib
import time
import random
import services
import datetime

# psyco, more unstable but a lot faster
import psyco
psyco.full() 

# Set the addon info data
info = es.AddonInfo()
info.name = 'SourceRPG'
info.version = '1.2.5'
info.url = 'http://addons.eventscripts.com/addons/view/sourcerpg'
info.basename = 'sourcerpg'
info.author = 'Freddukes AKA Pro Noob'


# Make Public Variable
sourcerpg = es.ServerVar('sourcerpg',info.version,'SourceRPG Version - Made by Freddukes').makepublic()

# Define Dictionaries

players = {}

# Set the dict options, so that each one can be made into a server variable for ease of setting

dict_options = {
'srpg_DebugMode'                     :[0,'The level of the debug'],
'srpg_Prefix'                        :['[SourceRPG]','The Prefix of all the message commands'],
'srpg_AnnounceXp'                    :[1,'Whether or not the user is told when he gets XP'],
'srpg_AnnounceOnSpawn'               :[1,'Whether or not the user is told how much XP he has on spawn'],
'srpg_LevelUp'                       :[1,'Announce globally that the user leveled up'],
'srpg_BotMaxLevel'                   :[500,'The maximum level a bot can aquire before he is reset'],
'srpg_MaxLevel'                      :[2500,'The maximum level a normal human player can aquire'],
'srpg_MaxLevelReset'                 :[1,'If enabled, when MaxLevel is reached, the stats are reset'],
'srpg_ServerLevelReset'              :[15000,'The top10 players levels added together before the server resets'],
'srpg_InactiveCounter'               :[7,'After this many days, players will be removed from the databse'],
'srpg_DisableUnfairAdvantageXp'      :[1,'Prevents people from gaining XP if there are no opposition on the other team.'],
'srpg_StartPopupStatus'              :[1,'The default activation status of the popup for every player to join the server'],
'srpg_ConverterOverwrite'            :[1,'If this is set to 1, then SourceRPG database overwrites players inside cssrpg.db if they both exist...'],
'srpg_DatabaseSaveType'              :["round end",'The time when the database will save: interval or round_end'],
'srpg_DatabaseIntervalLength'        :[120,'How often (in seconds) that the database will save if SaveType is "interval"'],

'srpg_SkillUpgradeSound'             :['ambient/machines/machine1_hit2.wav','Skill Upgrade Sound: Use \'\' to disable the sound'],
'srpg_SkillDowngradeSound'           :['vehicles/apc/apc_shutdown.wav','Skill Downgrade Sound: Use \'\' to disable the sound'],
'srpg_LevelUpSound'                  :['ambient/energy/whiteflash.wav','Level Up Sound: Use \'\' to disable the sound'],

'srpg_KillXp'                        :[15,'Amount of XP gained multiplied by the victims level'],
'srpg_DamageXp'                      :[1.0,'Amount of XP gained multiplied by the victims level per damage dealt'],
'srpg_KnifeXp'                       :[8.0,'Amount of XP gained multplied by the victims level per damage dealt with a knife'],
'srpg_HsXp'                          :[50,'How much extra XP recieved on top of the KillXP for getting a HeadShot'],
'srpg_BombPlantXp'                   :[25,'How much XP recieved from planting the Bomb'],
'srpg_BombDifuseXp'                  :[50,'How much XP recieved from diffusing the Bomb'],
'srpg_BombExplodeXp'                 :[25,'How much XP recieved from exploding the C4'],
'srpg_HostageFollowsXp'              :[10,'Amount of XP gained per hostage of the user that begins to follow'],
'srpg_HostageRescueXp'               :[10,'Amount of XP per hostage rescued'],

'srpg_StartXP'                       :[250,'How much EXP it takes to get to the first level'],
'srpg_StartCredits'                  :[5,'How many credits you get when you join the server for the first time'],
'srpg_XpIncrement'                   :[50,'How much the XP needed is incremented each level after level 1'],
'srpg_CreditIncrement'               :[5,'How many credits gained each level'],
'srpg_SellPercentage'                :[75,'The percent of the total credits recieved back when a player sells a skill'],

'srpg_Health'                        :[1,'Whether or not the Health ability is activated'],
'srpg_HealthMax'                     :[16,'Maximum level of the Health ability'],
'srpg_HealthCreditsStart'            :[15,'How much it costs to buy to level 1 of Health'],
'srpg_HealthCreditsIncrement'        :[10,'After level 1, this is how many credits it increments by each level'],
'srpg_HealthIncrement'               :[25,'The extra amount of health gained each Health Level'],

'srpg_Regen'                         :[1,'Whether or not the Regen ability is activated'],
'srpg_RegenMax'                      :[5,'Maximum level of the Regen ability'],
'srpg_RegenCreditsStart'             :[5,'How much it costs to buy to level 1 of Regen'],
'srpg_RegenCreditsIncrement'         :[10,'After level 1, this is how many credits it increments by each level'],
'srpg_RegenDelay'                    :[1,'The delay of the regeneration Loop.'],

'srpg_LongJump'                      :[1,'Whether or not the Long Jump ability is activated'],
'srpg_LongJumpMax'                   :[5,'Maximum level of the Long Jump ability'],
'srpg_LongJumpCreditsStart'          :[20,'How much it costs to buy to level 1 of Long Jump'],
'srpg_LongjumpCreditsIncrement'      :[15,'After level 1, this is how many credits it increments by each level'],

'srpg_RegenAmmo'                     :[1,'Whether or not the Regenerate Ammo ability is activated'],
'srpg_RegenAmmoMax'                  :[10,'Maximum level of the Regenerate Ammo ability'],
'srpg_RegenAmmoCreditsStart'         :[15,'How much it costs to buy to level 1 of Regen Ammo'],
'srpg_RegenAmmoCreditsIncrement'     :[10,'After level 1, this is how many credits it increments by each level'],
'srpg_RegenAmmoDelay'                :[3,'The delay between each loop of the Regen Ammo'],

'srpg_Vampire'                       :[1,'Whether or not the Vampire ability is activated'],
'srpg_VampireMax'                    :[10,'Maximum level of the Vampire ability'],
'srpg_VampireCreditsStart'           :[15,'How much it costs to buy level 1 of Vampire'],
'srpg_VampireCreditsIncrement'       :[10,'After level 1, this is how many credits it increments by each level'],

'srpg_Stealth'                       :[1,'Whether or not the Stealth ability is activated'],
'srpg_StealthMax'                    :[5,'Maximum level of the Stealth ability'],
'srpg_StealthCreditsStart'           :[15,'How much it costs to buy level 1 of Stealth'],
'srpg_StealthCreditsIncrement'       :[10,'After level 1, this is how many credits it increments by each level'],

'srpg_NapalmNade'                    :[1,'Whether or not the Napalm-Nade ability is activated'],
'srpg_NapalmNadeMax'                 :[10,'Maximum level of the Napalm-Nade ability'],
'srpg_NapalmNadeCreditsStart'        :[10,'How much it costs to buy level 1 of Napalm-Nade'],
'srpg_NapalmNadeCreditsIncrement'    :[10,'After level 1, this is how many credits it increments by each level'],

'srpg_IceStab'                       :[1,'Whether or not the Ice-Stab ability is activated'],
'srpg_IceStabMax'                    :[3,'Maximum level of the Ice-Stab ability'],
'srpg_IceStabCreditsStart'           :[20,'How much it costs to buy level 1 of Ice-Stab'],
'srpg_IceStabCreditsIncrement'       :[30,'After level 1, this is how many credits it increments by each level'],
'srpg_IceStabDamageReduction'        :[50,'Amount of damage to heal the user if he\'s frozen'],

'srpg_FrostPistol'                   :[1,'Whether or not the Frost Pistol ability is activated'],
'srpg_FrostPistolMax'                :[10,'Maximum level of the Frost Pistol ability'],
'srpg_FrostPistolCreditsStart'       :[20,'How much it costs to buy level 1 of Frost Pistol'],
'srpg_FrostPistolCreditsIncrement'   :[15,'After level 1, this is how many credits it increments by each level'],

'srpg_StunNade'                      :[1,'Whether or not the Stun Grenade ability is activated'],
'srpg_StunNadeMax'                   :[5,'Maximum level of the Stun Grenade ability'],
'srpg_StunNadeCreditsStart'          :[30,'How much it costs to buy level 1 of Stun Grenade'],
'srpg_StunNadeCreditsIncrement'      :[20,'After level 1, this is how many credits it increments by each level'],

'srpg_SmogNade'                      :[1,'Whether or not the Smog Grenade ability is activated'],
'srpg_SmogNadeMax'                   :[5,'Maximum level of the Smog Grenade ability'],
'srpg_SmogNadeCreditsStart'          :[20,'How much it costs to buy level 1 of Smog Grenade '],
'srpg_SmogNadeCreditsIncrement'      :[20,'After level 1, this is how many credits it increments by each level'],

'srpg_Speed'                         :[1,'Whether or not the Speed ability is activated'],
'srpg_SpeedMax'                      :[5,'Maximum level of the Speed ability'],
'srpg_SpeedCreditsStart'             :[20,'How much it costs to buy level 1 of Speed'],
'srpg_SpeedCreditsIncrement'         :[25,'After level 1, this is how many credits it increments by each level'],
'srpg_SpeedMaxMovementSpeed'         :[1.5,'The maximum speed a player can go with the speed ability.'],

'srpg_Gravity'                       :[1,'Whether or not the Gravity ability is activated'],
'srpg_GravityMax'                    :[10,'Maximum level of the Gravity ability'],
'srpg_GravityCreditsStart'           :[15,'How much it costs to buy level 1 of Gravity'],
'srpg_GravityCreditsIncrement'       :[10,'After level 1, this is how many credits it increments by each level'],
'srpg_GravityMinGravity'             :[0.3,'The minimum gravity a player is allowed to have at maximum gravity level.'],

'srpg_Disable'                       :[1,'Whether or not the Disable ability is activated'],
'srpg_DisableMax'                    :[10,'Maximum level of the Disable ability'],
'srpg_DisableCreditsStart'           :[15,'How much it costs to buy level 1 of Disable'],
'srpg_DisableCreditsIncrement'       :[10,'After level 1, this is how many credits it increments by each level'],
'srgp_DisableDropPercentage'         :[5,'This is how much percentage each level increases your percentage to disarm the victim.'],

'srpg_RecoverWeapons'                :[1,'Whether or not the Recover Weapons ability is activated'],
'srpg_RecoverWeaponsMax'             :[3,'Maximum level of the Recover Weapons ability'],
'srpg_RecoverWeaponsCreditsStart'    :[25,'How much it costs to buy level 1 of Recover Weapons'],
'srpg_RecoverWeaponsCreditsIncrement':[50,'After level 1, this is how many credits it increments by each level'],

'srpg_RegenArmor'                    :[1,'Whether or not the the Regenerate Armor ability is activated'],
'srpg_RegenArmorMax'                 :[10,'Maximum Level of Regenerate Armor'],
'srpg_RegenArmorCreditsStart'        :[5,'How much it costs to buy level 1 of Regenerate Armor'],
'srpg_RegenArmorCreditsIncrement'    :[10,'After level 1, this is how many credits it increments by each level'],
'srpg_RegenArmorDelay'               :[1,'The delay of the loop of Regenerate Armor'],

'srpg_Adrenaline'                    :[1,'Whether or not the the Adrenaline ability is activated'],
'srpg_AdrenalineMax'                 :[10,'Maximum Level of Adrenaline'],
'srpg_AdrenalineCreditsStart'        :[5,'How much it costs to buy level 1 of Adrenaline'],
'srpg_AdrenalineCreditsIncrement'    :[10,'After level 1, this is how many credits it increments by each level'],
'srpg_AdrenalineLength'              :[2,'How long in seconds the Adrenaline lasts for'],

'srpg_Medic'                         :[1,'Whether or not the the Medic ability is activated'],
'srpg_MedicMax'                      :[5,'Maximum Level of Medic'],
'srpg_MedicCreditsStart'             :[25,'How much it costs to buy level 1 of Medic'],
'srpg_MedicCreditsIncrement'         :[15,'After level 1, this is how many credits it increments by each level'],
'srpg_MedicMinDistance'              :[300,'The radius of the healing effect at level 1'],
'srpg_MedicDistanceIncrement'        :[50,'How much the radius grows each level'],
'srpg_MedicDelay'                    :[5,'The delay between the loops of the healing effect'],
'srpg_MedicHealingIncrement'         :[5,'The amount of health each loop will do, multiplied by the player\'s level'],
'srpg_MedicEffects'                  :[1,'Turn on/off the effects of the medic']
}

pistols = {'glock':int(es.ServerVar('ammo_9mm_max')),'usp':int(es.ServerVar('ammo_45acp_max')),'p228':int(es.ServerVar('ammo_357sig_max')),'deagle':int(es.ServerVar('ammo_50AE_max')),'fiveseven':int(es.ServerVar('ammo_57mm_max')),'elite':int(es.ServerVar('ammo_9mm_max'))}
rifles = {'m3':int(es.ServerVar('ammo_buckshot_max')),'xm1014':int(es.ServerVar('ammo_buckshot_max')),'tmp':int(es.ServerVar('ammo_9mm_max')),'mac10':int(es.ServerVar('ammo_45acp_max')),'ump45':int(es.ServerVar('ammo_45acp_max')),'mp5navy':int(es.ServerVar('ammo_9mm_max')),'p90':int(es.ServerVar('ammo_57mm_max')),'famas':int(es.ServerVar('ammo_556mm_max')),'galil':int(es.ServerVar('ammo_556mm_max')),'scout':int(es.ServerVar('ammo_762mm_max')),'ak47':int(es.ServerVar('ammo_762mm_max')),'m4a1':int(es.ServerVar('ammo_556mm_max')),'sg552':int(es.ServerVar('ammo_556mm_max')),'aug':int(es.ServerVar('ammo_762mm_max')),'g3sg1':int(es.ServerVar('ammo_762mm_max')),'sg550':int(es.ServerVar('ammo_556mm_max')),'awp':int(es.ServerVar('ammo_338mag_max')),'m249':int(es.ServerVar('ammo_556mm_box_max'))}
tempdict = {}
tokens = {}
smokedict = {}

# LangLib Text 
text = lambda x, y={}, lang='en': 'Invalid Text File'

def load():
    """
    Whenever the script loads, Load all the default stuff
    Check if players are on server, if so, replicate the
    player_activate event for all users so we can unload
    and load the script whilst playing without bugs
    """
    
    global players
    global text
    
    es.msg('#green','SourceRPG Loading - Created by Freddukes')
    debugMsg(0,'\n*******************************************************')
    debugMsg(0,'SourceRPG: Turning your Server into a Role Playing Game')
    debugMsg(0,'SourceRPG: Current Version - %s'%info.version)
    debugMsg(0,'SourceRPG: Made by Freddukes')
    
    # Setup Auth Services
    setup_auth()
    debugMsg(0,'SourceRPG: Successfully Set up Authorization Services.')
    
    # Make all options inside dict_options into a server variable so 
    # everything can be edited from within the game
    for a in dict_options:
        es.ServerVar(a,dict_options[a][0],dict_options[a][1])
    
    # Set the commands
    # 'command':['method','description'],
    mySayCommands = {
    'rpg_addxp':['AdminAddXp','Syntax: rpg_addxp <userid/name/steamid> <amount> [Reason]'],
    'rpg_addlevel':['AdminAddLevel','Syntax: rpg_addlevel <userid/name/steamid> <amount>'],
    'rpg_addcredits':['AdminAddCredit','Syntax: rpg_addcredits <userid/name/steamid> <amount> [reason]'],
    'rpg_admin':['SendAdminMenu','Syntax: rpg_admin'],
    'rpg_enableskills':['CheckDisableMenu','A command to change Enable/Disable of skills']
    }
    
    for myCommand in mySayCommands:
        if not es.exists('saycommand',myCommand):
            es.regsaycmd(myCommand, 'sourcerpg/' + mySayCommands[myCommand][0], mySayCommands[myCommand][1])
        if not es.exists('clientcommand',myCommand):
            es.regclientcmd(myCommand, 'sourcerpg/' + mySayCommands[myCommand][0], mySayCommands[myCommand][1])
    
    # Open the players.db, if it don't have one, create one.
    
    str_path = es.getAddonPath('sourcerpg') + '/players.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        players = cPickle.load(file_users)
        file_users.close()
        debugMsg(0,'SourceRPG: Successfully Loaded \'players.db\'')
    else:
        debugMsg(0,'SourceRPG: ERROR - No players.db found! Creating one now.')
        
    #Load both config files
        
    if os.path.isfile(es.getAddonPath('sourcerpg') + '/srpg.cfg'):
        es.server.cmd('es_xmexec ../addons/eventscripts/sourcerpg/srpg.cfg')
        debugMsg(0,'SourceRPG: Successfully Loaded \'srpg.cfg\'')
    else:
        debugMsg(0,'SourceRPG: ERROR - Unable to load srpg.cfg! Please ensure it is in the ./sourcerpg/ directory.')
        
    if os.path.isfile(es.getAddonPath('sourcerpg') + '/skills/skills.cfg'):
        es.server.cmd('es_xmexec ../addons/eventscripts/sourcerpg/skills/skills.cfg')
        debugMsg(0,'SourceRPG: Successfully Loaded \'skills.cfg\'')
    else:
        debugMsg(0,'SourceRPG: ERROR - Unable to load skills.cfg! Please ensure it is in the ./sourcerpg/skills/ directory.')
        
    # Convert the database from C++ CSS:RPG
    str_path = es.getAddonPath('sourcerpg') + '/cssrpg.db'
    if os.path.isfile(str_path):
        debugMsg(0,'SourceRPG: Found cssrpg.db! converting database now!')
        ConvertDatabase(str_path)
        
    # Open up the Langlib strings and reference them for easy reference later
        
    langpath = es.getAddonPath('sourcerpg') + '/languages.ini'
    if os.path.isfile(langpath):
        text = langlib.Strings(langpath)
        debugMsg(0,'SourceRPG: Successfully Loaded \'languages.ini\'')
    else:
        debugMsg(0,'SourceRPG: - ERROR Unable to load languages.ini! Please ensure it is in the ./sourcerpg/ directory.')
       
    helpmenu = popuplib.create('helpmenu')
    a = helpmenu.addline
    a('=== SourceRPG Help ===')
    a('-------------')
    a('->1. About SourceRPG')
    a('->2. List of Commands')
    a('->3. About SourceRPG Skills')
    a('->4. Credit')
    a('-------------')
    a('8. Back')
    a('0. Cancel')
    helpmenu.submenu(1,'aboutmenu')
    helpmenu.submenu(2,'commandmenu')
    helpmenu.submenu(3,'aboutskillsmenu')
    helpmenu.submenu(4,'creditmenu')
    helpmenu.submenu(8,'rpgmenu')
        
    """
    This checks to see if there are users playing when the script loads
    If so, make sure that each user has a key in the temp_dict, and
    check to see if they have a key in players.db, if not, make one.
    This makes it so we can unload/load whilst playing inside the game.
    """
      
    if len(es.getUseridList()):
        debugMsg(0,'SourceRPG WARNING: Attempting to load halfway through a map')
        debugMsg(0,'SourceRPG WARNING: This could cause errors, but trying anyway.')
        for a in es.getUseridList():
            a = str(a)
            steamid = ReturnSteam(a)
            if not players.has_key(steamid):
                players[steamid] = {'Level':1,'Xp':0,'Credits':es.ServerVar('srpg_StartCredits'),'Regen':0,'Health':0,'RegenAmmo':0,'Stealth':0,'Vampire':0,'NapalmNade':0,'IceStab':0,'FrostPistol':0,'LongJump':0,'Speed':0,'Gravity':0,'StunNade':0,'SmogNade':0,'RecoverWeapons':0,'Disable':0,'TotalTime':0.0}
                debugMsg(0,'SourceRPG: ' + es.getplayername(a) + ' Has been added to \'players.db\'')
                popuplib.send('helpmenu',a)
            if not players[steamid].has_key('RegenArmor'): 
                players[steamid]['RegenArmor'] = 0
            if not players[steamid].has_key('popup'):
                players[steamid]['popup'] = int(es.ServerVar('srpg_StartPopupStatus'))
            if not players[steamid].has_key('Adrenaline'):
                players[steamid]['Adrenaline'] = 0
                players[steamid]['Medic'] = 0
            players[steamid]['LastConnected'] = datetime.date.today()
            players[steamid]['Name'] = es.getplayername(a)
            start_time = time.time()
            
            es.server.queuecmd('mp_restartgame 1')
        debugMsg(0,'SourceRPG WARNING: Finished loaded halfway through a map. You may get a few errors.')
        
    debugMsg(0,'SourceRPG: Creating Popups')
    
    #Start of all the popups creating *sigh*
    
    rpgmenu = popuplib.create('rpgmenu')
    a = rpgmenu.addline
    a('=== SourceRPG Menu ===')
    a('-------------')
    a('->1. Upgrades')
    a('->2. Sell Skills')
    a('->3. Help')
    a('->4. RPG Stats')
    a('->5. Reset Skills')
    a('-------------')
    a('0. Cancel')
    rpgmenu.select(1,SendSkillsMenuFromPopup)
    rpgmenu.select(2,SendSellMenuFromPopup)
    rpgmenu.submenu(3,'helpmenu')
    rpgmenu.select(4,BuildStatsMenu)
    rpgmenu.submenu(5,'requestaccept')
    
    aboutmenu = popuplib.create('aboutmenu')
    a = aboutmenu.addline
    a('=== About SourceRPG ===')
    a('-------------')
    a('SourceRPG is a python coded mod')
    a('for EventScripts 2+. It enables')
    a('players to gain Levels, by gaining')
    a('XP from certain events, such as')
    a('planting the bomb, or killing')
    a('another player. Each level gives')
    a('%s Credits, which allows you to'%es.ServerVar('srpg_CreditIncrement'))
    a('buy certain skills which aid you')
    a('in killing other players.')
    a('-------------')
    a('8. Back')
    a('0. Cancel')
    aboutmenu.submenu(8,'helpmenu')
    
    commandmenu = popuplib.create('commandmenu')
    a = commandmenu.addline
    a('=== List of Commands ===')
    a('-------------')
    a('\'rpgmenu\' - Displays the main menu')
    a('\'rpgupgrade\' - Brings up the Upgrade menu')
    a('\'rpgsell\' - Brings up the Skills Shop')
    a('\'rpgrank\' - Displays your SourceRPG Rank')
    a('\'rpgrank <name>\' - Displays the SourceRPG rank of someone else')
    a('\'rpgtop10\' - Displays the SourceRPG Top10')
    a('\'rpghelp\' - Displays the help menu')
    a('\'rpgstats\' - Displays a stats popup page')
    a('\'rpgpopup\' - Toggles your popup display on or off')
    a('-------------')
    a('8. Back')
    a('0. Cancel')
    commandmenu.submenu(8,'helpmenu')
    
    aboutskillsmenu = popuplib.create('aboutskillsmenu')
    a = aboutskillsmenu.addline
    a('=== About SourceRPG Skills ===')
    a('           Page (1/3)         ')
    a('-------------')
    a('->1. Health+')
    a('->2. Regeneration')
    a('->3. Regenerate Ammo')
    a('->4. Napalm Grenade')
    a('->5. Vampire')
    a('->6. Stealth')
    a('->7. Long Jump')
    a('->8. Ice stab')
    a('-------------')
    a('->9. Next')
    a('->0. Back')
    aboutskillsmenu.submenu(1,'healthhelp')
    aboutskillsmenu.submenu(2,'regenhelp')
    aboutskillsmenu.submenu(3,'regenammohelp')
    aboutskillsmenu.submenu(4,'firenadehelp')
    aboutskillsmenu.submenu(5,'vampirehelp')
    aboutskillsmenu.submenu(6,'stealthhelp')
    aboutskillsmenu.submenu(7,'longjumphelp')
    aboutskillsmenu.submenu(8,'icestabhelp')
    aboutskillsmenu.submenu(9,'aboutskillsmenu2')
    aboutskillsmenu.submenu(10,'helpmenu')
    
    aboutskillsmenu2 = popuplib.create('aboutskillsmenu2')
    a = aboutskillsmenu2.addline
    a('=== About SourceRPG Skills ===')
    a('           Page (2/3)         ')
    a('-------------')
    a('->1. Frost Pistol')
    a('->2. Stun Grenades')
    a('->3. Smog Grenades')
    a('->4. Speed+')
    a('->5. Gravity-')
    a('->6. Disable')
    a('->7. Recover Weapons')
    a('-------------')
    a('->8. Back')
    a('->9. Next')
    aboutskillsmenu2.submenu(1,'frostpistolhelp')
    aboutskillsmenu2.submenu(2,'stunnadehelp')
    aboutskillsmenu2.submenu(3,'smognadehelp')
    aboutskillsmenu2.submenu(4,'speedhelp')
    aboutskillsmenu2.submenu(5,'gravityhelp')
    aboutskillsmenu2.submenu(6,'disablehelp')
    aboutskillsmenu2.submenu(7,'recoverweaponshelp')
    aboutskillsmenu2.submenu(8,'aboutskillsmenu')
    aboutskillsmenu2.submenu(9,'aboutskillsmenu3')
    
    aboutskillsmenu3 = popuplib.create('aboutskillsmenu3')
    a = aboutskillsmenu3.addline
    a('=== About SourceRPG Skills ===')
    a('           Page (3/3)         ')
    a('-------------')
    a('->1. Regenerate Armor')
    a('->2. Adrenaline')
    a('->3. Medic')
    a('-------------')
    a('->8. Back')
    a('0. Cancel')
    aboutskillsmenu3.submenu(1,'regenarmorhelp')
    aboutskillsmenu3.submenu(2,'adrenalinehelp')
    aboutskillsmenu3.submenu(3,'medichelp')
    aboutskillsmenu3.submenu(8,'aboutskillsmenu2')
    
    healthhelp = popuplib.create('healthhelp')
    a = healthhelp.addline
    a('=== Health+ ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_Health'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_HealthMax'))
    a(' ')
    a('Health+ is a skill which')
    a('allows the player to spawn')
    a('with more health. Each level')
    a('will give the player %s more'%es.ServerVar('srpg_HealthIncrement'))
    a('health upon spawn.')
    a('-------------')
    a('0. Back')
    healthhelp.submenu(10,'aboutskillsmenu')
    
    regenhelp = popuplib.create('regenhelp')
    a = regenhelp.addline
    a('=== Regeneration ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_Regen'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_RegenMax'))
    a(' ')
    a('Regeneration is an ability')
    a('which restores a certain')
    a('amount of health every')
    a('%s seconds. The amount you'%es.ServerVar('srpg_RegenDelay'))
    a('restore is the same amount')
    a('as your level')
    a('-------------')
    a('0. Back')
    regenhelp.submenu(10,'aboutskillsmenu')
    
    regenammohelp = popuplib.create('regenammohelp')
    a = regenammohelp.addline
    a('=== Regenerate Ammo ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_RegenAmmo'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_RegenAmmoMax'))
    a(' ')
    a('Regenerate ammo is a skill')
    a('which allows you to restore')
    a('your reserve ammo for your')
    a('active weapon every %s seconds.'%es.ServerVar('srpg_RegenAmmoDelay'))
    a('-------------')
    a('0. Back')
    regenammohelp.submenu(10,'aboutskillsmenu')
    
    firenadehelp = popuplib.create('firenadehelp')
    a = firenadehelp.addline
    a('=== Napalm Grenade ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_NapalmNade'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_NapalmNadeMax'))
    a(' ')
    a('Napalm grenade is an ability which')
    a('if a player is hit by your grenade')
    a('then he will be set on fire for ')
    a('a certain amount of time. The time')
    a('the player is burnt for is 1 seconds')
    a('for every level you have.')
    a('-------------')
    a('0. Back')
    firenadehelp.submenu(10,'aboutskillsmenu')
    
    vampirehelp = popuplib.create('vampirehelp')
    a = vampirehelp.addline
    a('=== Vampire ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_Vampire'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_VampireMax'))
    a(' ')
    a('Vampire is a skill which when you')
    a('attack another player, you will drain')
    a('a certain percentage of the damage done,')
    a('and restores it to your health. Every level')
    a('restores 7.5% of the damage done to your')
    a('health.')
    a('-------------')
    a('0. Back')
    vampirehelp.submenu(10,'aboutskillsmenu')
    
    stealthhelp = popuplib.create('stealthhelp')
    a = stealthhelp.addline
    a('=== Stealth ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_Stealth'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_StealthMax'))
    a(' ')
    a('The Stealth ability enables you to spawn')
    a('with a higher translutent figure, so you')
    a('appear more invisible. The higher the level')
    a('of stealth, the harder you are to see.')
    a('-------------')
    a('0. Back')
    stealthhelp.submenu(10,'aboutskillsmenu')
    
    longjumphelp = popuplib.create('longjumphelp')
    a = longjumphelp.addline
    a('=== Long Jump ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_LongJump'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_LongJumpMax'))
    a(' ')
    a('  SumGuy14 and Murphey Made this skill and')
    a('  allowed my to use it. Thanks guys!')
    a(' ')
    a('The long jump ability enables you to jump')
    a('further along the floor with each jump.')
    a('The higher level the skill, the further')
    a('you will jump.')
    a('-------------')
    a('0. Back')
    longjumphelp.submenu(10,'aboutskillsmenu')
    
    icestabhelp = popuplib.create('icestabhelp')
    a = icestabhelp.addline
    a('=== Ice Stab ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_IceStab'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_IceStabMax'))
    a(' ')
    a('Whenever you right click with the knife,')
    a('and you hurt another enemy from the opposite')
    a('team, they will freeze for a certain amount')
    a('of time dependant upon the level. Each level')
    a('will freeze the victim for 1 second.')
    a('-------------')
    a('0. Back')
    icestabhelp.submenu(10,'aboutskillsmenu')
    
    frostpistolhelp = popuplib.create('frostpistolhelp')
    a = frostpistolhelp.addline
    a('=== Frost Pistol ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_FrostPistol'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_FrostPistolMax'))
    a(' ')
    a('Frost pistol is a skill that happens whenever')
    a('you attack another player with a pistol. What')
    a('this skill does is slow your enemy for a certain')
    a('amount of time, dependant on your level. Each level')
    a('increases the time length it freezes the victim, and')
    a('also how effective the slow effect is.')
    a('-------------')
    a('0. Back')
    frostpistolhelp.submenu(10,'aboutskillsmenu2')
    
    stunnadehelp = popuplib.create('stunnadehelp')
    a = stunnadehelp.addline
    a('=== Stun Grenade ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_StunNade'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_StunNadeMax'))
    a(' ')
    a('Stun Grenade is flash grenade effect. Whenever')
    a('a victim is flashed via a flashbang, he can')
    a('also be frozen, and his screen is \'shaken\'.')
    a('The higher the level, the longer the victim is')
    a('frozen, and the more violent his screen is shaken.')
    a('-------------')
    a('0. Back')
    stunnadehelp.submenu(10,'aboutskillsmenu2')
    
    smognadehelp = popuplib.create('smognadehelp')
    a = smognadehelp.addline
    a('=== Smog Grenade ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_SmogNade'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_SmogNadeMax'))
    a(' ')
    a('  SuperDave Deserves credit for this skill. He made')
    a('  it and he\'s an excellent coder. Thank you SuperDave!')
    a(' ')
    a('This skill enables a posion gas to emit from smoke grenades.')
    a('Whenever you throw a smoke grenade, a poisonous gas appears')
    a('and victims to walk into it are damaged for the time they are')
    a('inside it. The damage emits every second, and the amount of')
    a('damage dealt is relevant to your Smog Grenade level. Each')
    a('level adds an extra damage to the poison.')
    a('-------------')
    a('0. Back')
    smognadehelp.submenu(10,'aboutskillsmenu2')
    
    speedhelp = popuplib.create('speedhelp')
    a = speedhelp.addline
    a('=== Speed+ ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_Speed'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_SpeedMax'))
    a(' ')
    a('Speed+ is a skill which increases your running')
    a('speed. The higher the level, the faster the speed.')
    a('The maximum level enables you to run at %sX the default'%es.ServerVar('srpg_SpeedMaxMovementSpeed')) 
    a('speed')
    a('-------------')
    a('0. Back')
    speedhelp.submenu(10,'aboutskillsmenu2')
    
    gravityhelp = popuplib.create('gravityhelp')
    a = gravityhelp.addline
    a('=== Gravity- ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_Gravity'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_GravityMax'))
    a(' ')
    a('Gravity- is a skill which lowers your gravity.')
    a('The higher the level, the lower your gravity.')
    a('Lower gravity enables you to jump higher.')
    a('At level %s, your gravity is %s percent of normal gravity'%(es.ServerVar('srpg_GravityMax'),(int(es.ServerVar('srpg_GravityMinGravity') * 100))))
    a('-------------')
    a('0. Back')
    gravityhelp.submenu(10,'aboutskillsmenu2')
    
    disablehelp = popuplib.create('disablehelp')
    a = disablehelp.addline
    a('=== Disable ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_Disable'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_DisableMax'))
    a(' ')
    a('Disable is an ability that works on percentages.')
    a('The higher the your level, the higher the chance')
    a('that the skill will happen. Each level increment')
    a('raises your chances of the ability from happening')
    a('by 5%. If your ability was successful, the victim')
    a('will be forced to drop his weapons, so he will')
    a('be disarmed until he picks it back up again.')
    a('-------------')
    a('0. Back')
    disablehelp.submenu(10,'aboutskillsmenu2')
    
    recoverweaponshelp = popuplib.create('recoverweaponshelp')
    a = recoverweaponshelp.addline
    a('=== Recover Weapons ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_RecoverWeapons'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_RecoverWeaponsMax'))
    a(' ')
    a('Recover Weapons is a skill which enables you to recover your')
    a('Weapons back if you die on the next round.')
    a('Level 1 - Restores NVG\'s, Unused Grenades and Vest//helm')
    a('Level 2 - Restores the above and Pistols')
    a('Level 3 - Restores the above and Primary Weapons')
    a('-------------')
    a('0. Back')
    recoverweaponshelp.submenu(10,'aboutskillsmenu2')
    
    regenarmorhelp = popuplib.create('regenarmorhelp')
    a = regenarmorhelp.addline
    a('=== Regenerate Armor ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_RegenArmor'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_RegenArmorMax'))
    a(' ')
    a('Regenerate Armor does exactly what it says on the tin...')
    a('It gives a certain amount of health back every %s seconds.'%(es.ServerVar('srpg_RegenArmorDelay')))
    a('This means that if you have a level 7 regenerate armor, then')
    a('you will gain 7 health every %s second.'%(es.ServerVar('srpg_RegenArmorDelay')))
    a('-------------')
    a('0. Back')
    regenarmorhelp.submenu(10,'aboutskillsmenu3')
    
    adrenalinehelp = popuplib.create('adrenalinehelp')
    a = adrenalinehelp.addline
    a('=== Adrenaline ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_Adrenaline'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_AdrenalineMax'))
    a(' ')
    a('Adrenaline allows you to get away from your enemies')
    a('in the most dire of times! When you are hit, you will')
    a('gain a quick speed boost to aid you turn tail and run.')
    a('Watch out though, the boost only lasts for %s seconds'%es.ServerVar('srpg_AdrenalineLength'))
    a('before you are reverted back to normal speed!')
    a('-------------')
    a('0. Back')
    adrenalinehelp.submenu(10,'aboutskillsmenu3')
    
    medichelp = popuplib.create('medichelp')
    a = medichelp.addline
    a('=== Medic ===')
    a('-------------')
    a('  %s'%IsEnabled(int(es.ServerVar('srpg_Medic'))))
    a('  Maximum Level: %s'%es.ServerVar('srpg_MedicMax'))
    a(' ')
    a('Medic allows you to heal your team-friends in a local')
    a('area. Every %s seconds, a healing wave will heal your'%es.ServerVar('srpg_MedicDelay'))
    a('friends in range. If your friends health is at their')
    a('maximum, then it will begin healing their armor instead.')
    a('-------------')
    a('0. Back')
    medichelp.submenu(10,'aboutskillsmenu3')
    
    creditmenu = popuplib.create('creditmenu')
    a = creditmenu.addline
    a('=== Credits ===')
    a('-------------')
    a('Freddukes (A.K.A Team TsX | Pro Noob)')
    a('  Script Creator')
    a(' ')
    a('SumGuy14 and Murphey')
    a('  Letting me use their Long Jump code')
    a(' ')
    a('SuperDave')
    a('  He turned my failing SmogNade code into')
    a('  a working code! Thank him for that skill.')
    a(' ')
    a('JoeyT2008 (Jordan Thomas)')
    a('  Awsome scripter who made the database conversion')
    a('  tool! Thank him for keeping all your skills! <3')
    a(' ')
    a('EventScripts Community')
    a('  Help and support, and such a good plugin.')
    a('-------------')
    a('8. Back')
    a('0. Cancel')
    creditmenu.submenu(8,'helpmenu')
    
    requestaccept = popuplib.create('requestaccept')
    a = requestaccept.addline
    a('=== WARNING!!! ===')
    a('-------------')
    a('This will pernamantly delete')
    a('your stats and information.')
    a('Do you wish to procceed?')
    a('There is no reversing the action!')
    a(' ')
    a('->1. Yes')
    a('->2. No')
    a('-------------')
    requestaccept.select(1,ResetSkills)
    
    adminmenu = popuplib.create('srpg_adminmenu')
    a = adminmenu.addline
    a('=== SourceRPG Admin ===')
    a('-------------')
    a('->1. Enabled/Disable Skills')
    a('->2. Give XP')
    a('->3. Give Levels')
    a('->4. Give Credits')
    a('->5. Search through the Database')
    a('->6. Delete Database')
    a('-------------')
    a('0. Cancel')
    adminmenu.select(1,CheckDisableMenuPopup)
    adminmenu.select(2,CreateXpPlayerList)
    adminmenu.select(3,CreateLevelPlayerList)
    adminmenu.select(4,CreateCreditPlayerList)
    adminmenu.select(5,BuildPeopleMenu)
    adminmenu.submenu(6,'ConfirmDeletion')
    
    cd = popuplib.create('ConfirmDeletion')
    a = cd.addline
    a('=== SourceRPG Admin===')
    a('---------------------------------')
    a('!!!WARNING!!!')
    a(' ')
    a('You are about to delete the whole')
    a('entire database. This will reset')
    a('all the players ranks, skills and')
    a('experience. Are you sure you want')
    a('to do this? There is nothing to')
    a('reverse this action once confirmed.')
    a(' ')
    a('->1. Yes')
    a('->0. No')
    cd.select(1,DeleteDatabase)
    cd.submenu(10,'srpg_adminmenu')
    
    debugMsg(0,'SourceRPG: Successfully created popups')
    
    # Phew, lots of popups just been made...
    
    # Turn noisy on to track weapon_fire so we can have napalm nades =]
    debugMsg(1,'\nTurning Noisy on now.....')
    debugMsg(1,'Pre Noisy is %s'%es.ServerVar('eventscripts_noisy'))
    es.doblock('corelib/noisy_on')
    debugMsg(1,'After Noisy is %s\n'%es.ServerVar('eventscripts_noisy'))
    
    if es.ServerVar('srpg_DatabaseSaveType') == "intervals":
        gamethread.delayedname(int(es.ServerVar('srpg_DatabaseIntervalLength')), 'save_interval', SaveDatabase)
    
    debugMsg(0,'SourceRPG: Finished Loading... Enjoy your stay!')
    debugMsg(0,'*******************************************************\n')
    
def SaveDatabase():
    global players
    debugMsg(1,'\n***********************')
    debugMsg(1,'SourceRPG: Saving Database')
    filepath = open(es.getAddonPath('sourcerpg') + '/players.db', 'w')
    cPickle.dump(players, filepath)
    filepath.close()
    if es.ServerVar('srpg_DatabaseSaveType') == "intervals":
        gamethread.delayedname(int(es.ServerVar('srpg_DatabaseIntervalLength')), 'save_interval', SaveDatabase)
    debugMsg(1,'SourceRPG: Database Saved!')
    debugMsg(1,'***********************\n')
    
def SendPopupMethods(userid, choice, popupid):
    # 'delete','xp','level','credit'
    steamid = es.ServerVar('srpg_steamid')
    if choice == 1:
        ResetSkills(steamid, None, None)
    elif choice == 2:
        CreateXpInputBox(userid, steamid, None)
    elif choice == 3:
        CreateLevelInputBox(userid, steamid, None)
    elif choice == 4:
        CreateCreditInputBox(userid, steamid, None)
        
def unload():
    """
    This method is called whenever the script is unloaded. Saves the player.db
    and resets everyones stats back to 'normal' attributes, such as gravity etc.
    """
    global players
    es.msg('#green','SourceRPG Unloading - Created by Freddukes')
    debugMsg(0,'*******************************************************')
    debugMsg(0,'SourceRPG: Returning back to normal')
    if len(es.getUseridList()):
        debugMsg(0,'SourceRPG: Resetting players attributes to normal gameplaye')
        for a in es.getUseridList():
            es.server.queuecmd('est_SetGravity %s 1.0'%a)
            es.server.queuecmd('est_SetPlayerColor %s 255 255 255 255'%a)
        debugMsg(0,'SourceRPG: Everyone\s stats reset to normal')
    debugMsg(0,'SourceRPG: Saving Player.db')
    SaveDatabase()
    gamethread.cancelDelayed('SmokeUpdate')
    gamethread.cancelDelayed('save_interval')
    es.server.queuecmd('mp_restartgame')
    debugMsg(0,'SourceRPG: Successfully Unloaded.')
    debugMsg(0,'*******************************************************')
        
def es_map_start(ev):
    debugMsg(1,'\nSourceRPG: Map Start Activated!')
    if int(es.ServerVar('srpg_ServerLevelReset')):
        debugMsg(1,'Testing server level reset!')
        a = sorted(players,SortRank)
        level = 0
        for index in range(min(11,len(a))):
            if int(es.ServerVar('srpg_DebugMode')) >= 2:
                debugMsg(2,'Testing rank %s on the server.'%index)
                debugMsg(2,'Level Before addition - %s'%level)
            level += int(players[a[index]]['Level'])
            debugMsg(2,'Level After addition - %s'%level)
        if level >= int(es.ServerVar('srpg_ServerLevelReset')):
            if int(es.ServerVar('srpg_DebugMode')):
                debugMsg(1,'Top 10 levels is bigger than the Server Level Reset, so resetting!')
                debugMsg(1,'SourceRPG: Out of Map Start Method!\n')
            DeleteDatabase(None, None, None)
            return
    date = datetime.date.today() - datetime.timedelta(int(es.ServerVar('srpg_InactiveCounter')))
    debugMsg(1,'Testing for inactive players: Everyone that was last active before %s will be delted.'%date)
    deleted = []
    for player in players:
        if not players[player].has_key('LastConnected'):
            players[player]['LastConnected'] = datetime.date.today()
        else:
            time = players[player]['LastConnected']
            debugMsg(2,'Steamid %s las connected on %s'%(player,time))
            if time < date:
                deleted.append(player)
    for player in deleted:
        debugMsg(1,'Deleting Player - %s'%player)
        del players[player]
    debugMsg(1,'SourceRPG: Out of Map Start Method!\n')
        
def player_activate(ev):
    """
    Called whenever a user connects to the server and is activated.
    Here we will get the steamid of the user, and see if he has a 
    place inside the players.db. If not, create one. It will also
    Create a temp_dict, which will set things like max health, so we
    only need to calculate max_health once, then we've got easy reference
    throughout the rest of the script.
    """
    global players
    debugMsg(1, '\nSourceRPG: Player activate method')
    steamid = ReturnSteam(ev['userid'])
    if not players.has_key(steamid):
        debugMsg(1, 'New player has just joined, create a new table for him.')
        players[steamid] = {'Level':1,'Xp':0,'Credits':es.ServerVar('srpg_StartCredits'),'Regen':0,'Health':0,'RegenAmmo':0,'Stealth':0,'Vampire':0,'NapalmNade':0,'IceStab':0,'FrostPistol':0,'LongJump':0,'Speed':0,'Gravity':0,'StunNade':0,'SmogNade':0,'RecoverWeapons':0,'Disable':0,'TotalTime':0.0,'popup':1}
        debugMsg(0,'SourceRPG: ' + ev['es_username'] + ' Has been added to \'players.db\'')
        popuplib.send('helpmenu',ev['userid'])
    if not players[steamid].has_key('RegenArmor'): 
        players[steamid]['RegenArmor'] = 0
        debugMsg(1, 'Player did not have a \'RegenArmor\' key')
    if not players[steamid].has_key('popup'):
        debugMsg(1, 'Player did not have a \'popup\' key')
        players[steamid]['popup'] = int(es.ServerVar('srpg_StartPopupStatus'))
    if not players[steamid].has_key('Adrenaline'):
        debugMsg(1, 'Player did not have an \'Adrenaline\' or \'Medic\' key.')
        players[steamid]['Adrenaline'] = 0
        players[steamid]['Medic'] = 0
    players[steamid]['Name'] = ev['es_username']
    players[steamid]['LastConnected'] = datetime.date.today()
    command = Command(ev['userid'])
    command.ResetDict()
    command.ResetRecover()
    command.UpdateDict('StartTime', time.time())
    debugMsg(1, 'SourceRPG: Out of Player Activate!\n')
    
def player_team(ev):
    '''
    This event occurs when a player changes team
    It is here to remove the weapons gained from
    recover active skill
    '''
    Command(ev['userid']).ResetRecover()
    
def player_disconnect(ev):
    """
    Called whenever a player is disconnected from your server.
    This will attempt to delete all custom popups that we have
    made for the user, as to save resources. Also, we will see if
    the server is not a LAN... If it is, for some reason there will
    be weird errors as playerlib.uniqueid will say 'Cannot find user'.
    """
    global players
    for pName in ['skill','sell','stats','s']:
        realPName = pName + '_' + ev['userid']
        if popuplib.exists(realPName):
            popuplib.delete(realPName)
    if 'BOT' not in ev['networkid'] and 'LAN' not in ev['networkid']:
        start_time = Command(ev['userid']).ReturnDict('StartTime')
        end_time = time.time()
        time_elapsed = '%.2f'%((end_time - start_time) / 3600.0)
        players[ev['networkid']]['TotalTime'] += float(time_elapsed)
    del command_dict[int(ev['userid'])]
    
def round_end(ev):
    """
    Round end just simply saves the players.db whenever the round ends
    """
    if es.ServerVar('srpg_DatabaseSaveType') == "round end":
        SaveDatabase()
    gamethread.cancelDelayed('SmokeUpdate')
    for player in filter(lambda x: not es.getplayerprop(x, 'CBasePlayer.pl.deadflag'), es.getUseridList() ):
        gamethread.cancelDelayed('medic_%s'%player)
    
def round_freeze_end(ev):
    """
    Start the delay to check for smokegrenade positions
    """
    gamethread.delayedname(1, 'SmokeUpdate', sg_update)
        
"""
Below is just a list of all the events which gain XP for the player.
"""
        
def bomb_planted(ev):
    if int(es.ServerVar('srpg_DisableUnfairAdvantageXp')):
        if not len(playerlib.getPlayerList('#ct,#alive')): return
    steamid = ReturnSteam(ev['userid'])
    if int(es.ServerVar('srpg_BombPlantXp')):
        xp = int(es.ServerVar('srpg_BombPlantXp')) * players[steamid]['Level']
        AddXp(ev['userid'], steamid, xp, ' for Planting the Bomb')
    
def bomb_exploded(ev):
    if int(es.ServerVar('srpg_DisableUnfairAdvantageXp')):
        if not len(playerlib.getPlayerList('#ct,#alive')): return
    steamid = ReturnSteam(ev['userid'])
    if int(es.ServerVar('srpg_BombExplodeXp')):
        xp = int(es.ServerVar('srpg_BombExplodeXp')) * players[steamid]['Level']
        AddXp(ev['userid'], steamid, xp, ' for The C4 Exploding')
    
def bomb_difused(ev):
    if int(es.ServerVar('srpg_DisableUnfairAdvantageXp')):
        if not len(playerlib.getPlayerList('#t,#alive')): return
    steamid = ReturnSteam(ev['userid'])
    if int(es.ServerVar('srpg_BombDifuseXp')):
        xp = int(es.ServerVar('srpg_BombDifuseXp')) * players[steamid]['Level']
        AddXp(ev['userid'], steamid, xp, ' for Diffusing the bomb')

def hostage_follows(ev):
    if int(es.ServerVar('srpg_DisableUnfairAdvantageXp')):
        if not len(playerlib.getPlayerList('#t,#alive')): return
    steamid = ReturnSteam(ev['userid'])
    if int(es.ServerVar('srpg_HostageFollowsXp')):
        xp = int(es.ServerVar('srpg_HostageFollowsXp')) * players[steamid]['Level']
        AddXp(ev['userid'], steamid, xp, ' for Reaching a Hostage')

def hostage_rescued(ev):
    if int(es.ServerVar('srpg_DisableUnfairAdvantageXp')):
        if not len(playerlib.getPlayerList('#t,#alive')): return
    steamid = ReturnSteam(ev['userid'])
    if int(es.ServerVar('srpg_HostageRescueXp')):
        xp = int(es.ServerVar('srpg_HostageRescueXp')) * players[steamid]['Level']
        AddXp(ev['userid'], steamid, xp, ' for Rescuing a Hostage')

"""
End of list of all the events which gain XP for the Player.
"""

def player_spawn(ev):
    """
    Called whenever a player spawns. Here we will check for health,
    stealth, gravity, speed and regenerate weapons
    """
    global tokens
    if int(es.ServerVar('srpg_DebugMode')):
        debugMsg(1,'\n***********************')
        debugMsg(1,'SourceRPG: Player Spawn Event!')
        debugMsg(1,'***********************')
    uid = str(ev['userid'])
    debugMsg(1,'Testing userid: %s'%uid)
    command = Command(uid)
    steamid = ReturnSteam(uid)
    debugMsg(1,'Testing steamid: %s'%steamid)
    command.ResetDict()
    if int(es.ServerVar('srpg_Health')):
        debugMsg(1,'Setting player\'s max health to %s'%command.ReturnDict('MaxHealth'))
        es.setplayerprop(uid,'CBasePlayer.m_iHealth',command.ReturnDict('MaxHealth'))
    gamethread.delayed(int(es.ServerVar('srpg_RegenArmorDelay')), command.RegenArmor())
    if players.has_key(steamid):
        if int(es.ServerVar('srpg_AnnounceOnSpawn')):
            level = players[steamid]['Level']
            xp = players[steamid]['Xp']
            nextlevelxp = (level - 1) * int(es.ServerVar('srpg_XpIncrement')) + int(es.ServerVar('srpg_StartXP'))
            tokens = {'level':level,'xp':xp,'nextxp':nextlevelxp,'prefix':es.ServerVar('srpg_Prefix')}
            es.tell(uid,'#multi',text('level gained private', tokens, playerlib.getPlayer(uid).get('lang')))
        command.Color(255, 255, 255)
        if players[steamid]['Speed'] and int(es.ServerVar('srpg_Speed')):
            debugMsg(1,'Setting Players speed to %s'%command.ReturnDict('MaxSpeed'))
            command.Speed(command.ReturnDict('MaxSpeed'))
        if players[steamid]['Regen'] and int(es.ServerVar('srpg_Regen')):
            command.Regen()
        if players[steamid]['RegenArmor'] and int(es.ServerVar('srpg_RegenArmor')):
            command.RegenArmor()
        if players[steamid]['Gravity'] and int(es.ServerVar('srpg_Gravity')):
            debugMsg(1,'Setting Players graviy to %s'%command.ReturnDict('MaxGrav'))
            es.server.queuecmd('est_SetGravity %s %s'%(uid,command.ReturnDict('MaxGrav')))
        if int(es.ServerVar('srpg_RecoverWeapons')) and command.ReturnDict('RecoverActive') and players[steamid]['RecoverWeapons']:
            debugMsg(1,'Recover weapons is active')
            command.UpdateDict('RecoverActive',0)
            if not playerlib.getPlayer(uid).get('weaponindex', 'knife'):
                es.server.queuecmd('es_xgive %s weapon_knife'%uid)
            if command.ReturnDict('RecoverHe'):
                if not es.getplayerprop(uid, "CBasePlayer.localdata.m_iAmmo.011"):
                    es.server.queuecmd('es_xgive %s weapon_hegrenade'%uid)
            if command.ReturnDict('RecoverSmoke'):
                if not es.getplayerprop(uid, 'CBasePlayer.localdata.m_iAmmo.012'):
                    es.server.queuecmd('es_xgive %s weapon_smokegrenade'%uid)
            if command.ReturnDict('RecoverVest'):
                es.server.queuecmd('es_xgive %s item_kevlar'%uid)
            if command.ReturnDict('RecoverNvgs'):
                es.server.queuecmd('es_xgive %s item_nvgs'%uid)
            if command.ReturnDict('RecoverVestHelm'): 
                es.server.queuecmd('es_xgive %s item_assaultsuit'%uid)
            fbc = command.ReturnDict('RecoverFlashbang')
            while fbc:
                if int(es.getplayerprop(uid, 'CBasePlayer.localdata.m_iAmmo.012')) < 2:
                    fbc -= 1
                    command.ModDict('RecoverFlashbang', -1)
                    es.server.queuecmd('es_xgive %s weapon_flashbang'%uid)
                else: break
            if players[steamid]['RecoverWeapons'] > 1:
                if command.ReturnDict('RecoverSecondary') not in ['0',0,None,'weapon_glock','weapon_usp']:
                    if ev['es_userteam'] == '3': es.server.cmd('es_xfire %s weapon_usp kill'%uid)
                    if ev['es_userteam'] == '2': es.server.cmd('es_xfire %s weapon_glock kill'%uid)
                    gamethread.delayed(0.1, es.server.cmd, 'es_xgive %s %s'%(uid,command.ReturnDict('RecoverSecondary')))
            if players[steamid]['RecoverWeapons'] > 2:
                if command.ReturnDict('RecoverPrimary') not in ['0',0,None]:
                    gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s %s'%(uid, command.ReturnDict('RecoverPrimary')))
            debugMsg(1,'End of Recover weapons')
        if int(es.ServerVar('srpg_Medic')) and players[steamid]['Medic']:
            debugMsg(1,'Starting Medic Loop')
            command.MedicLoop()
        if int(es.ServerVar('srpg_DebugMode')):
            debugMsg(1,'***********************')
            debugMsg(1,'SourceRPG: End of Player Spawn')
            debugMsg(1,'***********************\n')

def round_start(ev):
    """An event just to send a message on Round Start"""
    for player in playerlib.getPlayerList('#all'):
        es.tell(int(player), '#multi', text('round start', {'prefix':str(es.ServerVar('srpg_Prefix'))}, player.get('lang')))

def player_say(ev):
    """
    Called whenever a player types anything in chat. Here we will get the text,
    strip it, and make it lower case. Then we will test the first argument to see
    if it matches an RPG command, if so run the following command. Here we will be
    defining the commands:
    
    rpgmenu - The main menu of the script. The popup which is central to all others
    rpgupgrade - Shortcut to the 'upgrade skills' popup.
    rpgsell - Shortcut to the 'sell upgrade' popup.
    rpghelp - Help menu
    rpgtop10 - Sort the dictionary by level, then make it so it so it will add the first
               10 indexs to the popup. Will also check if there aren't 10 users then break.
    rpgrank - Send a simple message to the player. Will need to sort the dictionary, then
              find the index of the steamid. Also len(dictionary) to get the total ranked 
              players. Also test to see if there's another argument to find a rank of another
              person.
    rpgstats - Shortcut to the stats popup.
    *new* rpgpopup - Enable/Disable popups. Check to see about their status of 'popup' in 
                     players.db. If it equals 0, then turn it on, else turn it off    
    """
    t = ev['text'].lower()
    t = t.split()
    if t[0] == "rpgmenu":
        popuplib.send('rpgmenu',ev['userid'])
    elif t[0] == "rpgupgrade":
        steamid = ReturnSteam(ev['userid'])
        CreateSkillMenu(ev['userid'],steamid)
        skillmenu = 'skill_%s'%ev['userid']
        popuplib.send(skillmenu, ev['userid'])
    elif t[0] == "rpghelp":
        popuplib.send('helpmenu',ev['userid'])
    elif t[0] == "rpgsell":
        steamid = ReturnSteam(ev['userid'])
        CreateSellMenu(ev['userid'],steamid)
        sellmenu = 'sell_%s'%ev['userid']
        popuplib.send(sellmenu, ev['userid'])
    elif t[0] == "rpgtop10":
        a = sorted(players,SortRank)
        index = 0
        try:
            popuplib.delete('top5')
            top5 = popuplib.create('top5')
        except ValueError:
            top5 = popuplib.create('top5')
        top5.addline('=== SourceRPG Top10 ===')
        top5.addline('        Ranks 1 - %s       '%('5' if len(a) >= 5 else len(a)))
        top5.addline('-----------------------')
        while index < 5:
            try:
                steam = a[index]
                index += 1
                if players[steam].has_key('Name'):
                    name = players[steam]['Name']
                else:
                    name = '[Unnamed]'
                level = players[steam]['Level']
                credits = players[steam]['Credits']
                xp = players[steam]['Xp']
                index_temp = index
                if len(name) > 16:
                    name = name[0:14]+'...'
                format = '->%s. %s - Level: %s Exp: %s Credits: %s'%(index_temp, name, level, xp, credits)
                top5.addline(format)
            except IndexError:
                index += 1
                top5.addline(' ')
        top5.addline('-----------------------')
        top5.addline(' ')
        if len(a) > 5: top5.addline('9. Rank 6 - %s'%('10' if len(a) >= 10 else len(a)))
        top5.addline('0. Cancel')
        if len(a) > 5: 
            top5.submenu(9,'top10')
            try:
                popuplib.delete('top10')
                top10 = popuplib.create('top10')
            except ValueError:
                top10 = popuplib.create('top10')
            top10.addline('=== SourceRPG Top10 ===')
            top10.addline('        Ranks 6 - %s      '%('10' if len(a) >= 10 else len(a)))
            top10.addline('-----------------------')
            while index < 10:
                try:
                    steam = a[index]
                    index += 1
                    if players[steam].has_key('Name'):
                        name = players[steam]['Name']
                    else:
                        name = '[Unnamed]'
                    level = players[steam]['Level']
                    credits = players[steam]['Credits']
                    xp = players[steam]['Xp']
                    index_temp = index
                    if len(name) > 16:
                        name = name[0:14]+'...'
                    format = '->%s. %s - Level: %s Exp: %s Credits: %s'%(index_temp, name, level, xp, credits)
                    top10.addline(format)
                except IndexError:
                    index += 1
                    top10.addline(' ')
                    
            top10.addline('-----------------------')
            top10.addline('8. Rank 1 - 5')
            top10.addline(' ')
            top10.addline('0. Cancel')
            top10.submenu(8,'top5')
            
        top5.send(ev['userid'])
    elif t[0] == "rpgrank":
        try:
            user = es.getuserid(t[1])
            if user:
                usteam = ReturnSteam(user)
                uname = es.getplayername(user)
                SendRank(usteam,uname)
        except IndexError:
            steamid = ReturnSteam(ev['userid'])
            SendRank(steamid,ev['es_username'])
    elif t[0] == "rpgstats":
        userid = ev['userid']
        try:
            popuplib.delete('stats_%s'%userid)
        except ValueError: pass
        sid = ReturnSteam(ev['userid'])
        
        b = sorted(players,SortRank)
        position = b.index(sid) + 1
        total = len(b)
        
        nextlevelxp = (players[sid]['Level'] - 1) * int(es.ServerVar('srpg_XpIncrement')) + int(es.ServerVar('srpg_StartXP'))
        
        statsmenu = popuplib.create('stats_%s'%userid)
        a = statsmenu.addline
        a('=== SourceRPG Stats ===')
        a('-------------')
        a('Total Time: %.2f hours'%players[sid]['TotalTime'])
        a(' ')
        a('Level: %s'%players[sid]['Level'])
        a('XP: %s/%s'%(players[sid]['Xp'],nextlevelxp))
        a('XP Needed to Level: %s'%(nextlevelxp - players[sid]['Xp']))
        a('Rank: %s/%s'%(position,total))
        a(' ')
        a('-------------')
        a('9. Skill Stats')
        a('0. Back')
        statsmenu.select(9,SendSkillStats)
        statsmenu.submenu(10,'rpgmenu')
        statsmenu.send(userid)
    elif t[0] == "rpgpopup":
        userid = ev['userid']
        sid = ReturnSteam(ev['userid'])
        es.tell(userid,'#multi','#default%s #greenYou have turned your popups #lightgreen%s#green. Type #lightgreen\'rpgpopop\' #greento#lightgreen %s#green.'%((es.ServerVar('srpg_Prefix')),('on' if not players[sid]['popup'] else 'off'),('De-Activate' if not players[sid]['popup'] else 'Activate')))
        players[sid]['popup'] = (1 if not players[sid]['popup'] else 0)
    elif t[0] == "rpg_admin2":
        userid = ev['userid']
        BuildPeopleMenu(userid)

def player_hurt(ev):
    """
    Called whenever a player is damaged. Define a lot of skills here:
    
    FireNade - Make sure that we delay, then call the extinguish block...
    IceStab - Set players color blue, then turn back after x seconds and unfreeze
    frostpistol - Same as IceStab except slow down to half speed instead of freeze
    vampire - Restore X percent of damage done to your own health
    Adrenaline - when hit speed the player up for X amount of seconds.
    Also start the Regen and RegenArmor skills...
    
    AddXP to the Attacker.. (X times the users level)
    """
    usid = ReturnSteam(ev['userid'])
    cmd = Command(ev['userid'])
    acmd = Command(ev['attacker'])
    if int(ev['attacker']):
        if not es.exists('userid',ev['attacker']):
            return
        asid = ReturnSteam(ev['attacker'])
        if ev['es_userteam'] != ev['es_attackerteam']:
            if ev['weapon'] == "hegrenade" and int(es.ServerVar('srpg_NapalmNade')) and players[asid]['NapalmNade']:
                es.server.cmd('es_xfire %s !self ignite'%ev['userid'])
                if players[asid]['NapalmNade']: gamethread.delayed(players[asid]['NapalmNade'],extinguish,ev['userid'])
            elif ev['weapon'] == "knife" and int(es.ServerVar('srpg_IceStab')):
                if int(ev['dmg_health']) > 40 and players[asid]['IceStab']:
                    if not acmd.ReturnDict('Frozen'):
                        cmd.UpdateDict('Frozen',1)
                        cmd.Freeze(players[asid]['IceStab'])
                        cmd.Color(100, 100, 255, time=players[asid]['IceStab'])
                        gamethread.delayed(players[asid]['IceStab'], cmd.UpdateDict, ('Frozen', 0))
                else:
                    pass
                    # Here, I'm going to do some sort of check to stop people who knife fight with left click...
                if int(es.ServerVar('srpg_KnifeXp')): 
                    AddXp(ev['attacker'],asid,((int(es.ServerVar('srpg_KnifeXp')) - int(es.ServerVar('srpg_DamageXp'))) * int(ev['dmg_health'])),'',False)
            elif ev['weapon'] in pistols and players[asid]['FrostPistol'] and int(es.ServerVar('srpg_FrostPistol')):
                cmd.Slow(players[asid]['FrostPistol'] / 20.0, players[asid]['FrostPistol']/10.)
                cmd.Color(100, 100, 255, time=players[asid]['FrostPistol']/10.)
            if ev['weapon'] in pistols or ev['weapon'] in rifles:
                if cmd.ReturnDict('Frozen') and int(es.ServerVar('srpg_IceStabDamageReduction')):
                    cmd.Heal(int(int(es.ServerVar('srpg_IceStabDamageReduction')) * int(ev['dmg_health']) / 100.0))
            if asid and players[asid]['Disable'] and int(es.ServerVar('srpg_Disable')):
                rand = random.randint(1,100)
                if rand <= (players[asid]['Disable'] * int(es.ServerVar('srgp_DisableDropPercentage'))):
                    es.sexec(ev['userid'],'drop')
            if asid and players[asid]['Vampire'] and int(es.ServerVar('srpg_Vampire')):
                health = int(ev['dmg_health'])
                health = int(((health * int(players[asid]['Vampire'])) * 7.5) / 100)
                acmd.Heal(health)
            AddXp(ev['attacker'],asid,(int(es.ServerVar('srpg_DamageXp')) * int(ev['dmg_health'])),'',False)
            if players[usid]['Adrenaline'] and int(es.ServerVar('srpg_Adrenaline')):
                if not cmd.ReturnDict('AlreadyAdrenalined'):
                    cmd.UpdateDict('AlreadyAdrenalined', 1)
                    amount = players[usid]['Adrenaline'] / 10.0
                    cmd.SpeedAdd(amount)
                    gamethread.delayed(int(es.ServerVar('srpg_AdrenalineLength')), cmd.SpeedAdd, amount * -1)
                    gamethread.delayed(int(es.ServerVar('srpg_AdrenalineLength')), cmd.UpdateDict, ('AlreadyAdrenalined',0))
    if players[usid]['Regen'] and int(es.ServerVar('srpg_Regen')):
        cmd.Regen()
    if players[usid]['RegenArmor'] and int(es.ServerVar('srpg_RegenArmor')):
        cmd.RegenArmor()
        
def player_death(ev):
    """
    Here we stop the 'fire' sounds so it don't annoy people...
    Here the only skill we check for is recoverweapons... If he
    dies and he has the skill, then we tell the dict that next round
    we want to restore his weapons. Also add's xp (X times users level)
    """
    cmd = Command(ev['userid'])
    steamid = ReturnSteam(ev['userid'])
    for sound in ('nature/fire/fire_small1.wav', 'fire/fire_big_loop1.wav', 'fire/fire_med_loop1.wav', 'fire/fire_small_loop2.wav', 'fire/gascan_ignite1.wav'):
		es.stopsound(ev['userid'], 'ambient/%s'%sound)
    asteamid = ReturnSteam(ev['attacker'])
    if int(es.ServerVar('srpg_RecoverWeapons')) and players[steamid]['RecoverWeapons']:
        cmd.UpdateDict('RecoverActive', 1)
        if not int(ev['es_userarmor']):
            cmd.UpdateDict('Vest', 0)
            cmd.UpdateDict('VestHelm', 0)
    if ev['es_userteam'] != ev['es_attackerteam']:
        if asteamid:
            AddXp(ev['attacker'],asteamid,(int(es.ServerVar('srpg_KillXp')) * players[steamid]['Level']),' for Killing ' + ev['es_username'])
            if int(ev['headshot']):
                AddXp(ev['attacker'],asteamid,int(es.ServerVar('srpg_HsXp')),' for getting a headshot')
    gamethread.cancelDelayed('medic_%s'%ev['userid'])
    
def hegrenade_detonate(ev):
    """
    Just deducts 1 if the user is set to have his HE's restored nextround.
    """
    u = Command(ev['userid'])
    if u.ReturnDict('RecoverHe') and int(es.ServerVar('srpg_RecoverWeapons')):
        u.UpdateDict('RecoverHe',0)
        
def flashbang_detonate(ev):
    """
    Deducts 1 if the user is set to have his Flashbangs restored next round.
    Also checks for the 'StunNade' skill.
    Get the location of the flashbang, then check if any people on the oposite team
    are near to the bang. If so, then shake their screen for X seconds, and half 
    their speed for X seconds.
    """
    if int(es.ServerVar('srpg_StunNade')):
        u = ev['userid']
        cmd = Command(u)
        steamid = ReturnSteam(u)
        if cmd.ReturnDict('RecoverFlashbang'):
            cmd.ModDict('RecoverFlashbang',-1)
        if players[steamid]['StunNade']:
            x = float(ev['x'])
            y = float(ev['y'])
            z = float(ev['z'])
            Distance = players[steamid]['StunNade'] * 50
            ShakeTime = players[steamid]['StunNade'] * 2
            ShakePower = ShakeTime * 50
            for loop_player in playerlib.getPlayerList('#t,#alive' if int(ev['es_userteam']) == 3 else '#ct,#alive'):
                loop_player = int(loop_player)
                xx, yy, zz = es.getplayerlocation(loop_player)
                if abs(x - xx) <= Distance and abs(y - yy) <= Distance and abs(z - zz) <= Distance:    
                    es.server.cmd('est_Shake %s %s %s %s'%(loop_player, ShakeTime, ShakePower, ShakePower))
                    Command(loop_player).Slow(Command(loop_player).ReturnDict('MaxSpeed') / 2.0, ShakeTime)
    
def weapon_reload(ev):
    """
    Starts the RegenAmmo skill.
    """
    steamid = ReturnSteam(ev['userid'])
    if players[steamid]['RegenAmmo'] and int(es.ServerVar('srpg_RegenAmmo')):
        Command(ev['userid']).RegenAmmo()

def weapon_fire(ev):
    """
    If the user has a NapalmLevel, then ignite the grenade to look cool
    """
    if int(es.ServerVar('srpg_NapalmNade')):
        steamid = ReturnSteam(ev['userid'])
        if ev['weapon'] == "hegrenade":
            if players[steamid]['NapalmNade']:
                gamethread.delayed(0.1,es.server.cmd,'es_xfire %s hegrenade_projectile ignite'%ev['userid'])

def item_pickup(ev):
    """
    Here's where we define what the user is going to respawn next round if 
    he has the restoreweapons skill. If level 1, then restore items, 2, pistols,
    3, primary weapons. Note: Cannot have USP or Glock, as you pick those up on spawn.
    """
    cmd = Command(ev['userid'])
    steamid = ReturnSteam(ev['userid'])
    if players.has_key(steamid):
        if players[steamid]['RegenAmmo'] and int(es.ServerVar('srpg_RegenAmmo')):
            if ev['item'] in pistols or ev['item'] in rifles:
                cmd.RegenAmmoLoop()
        if int(es.ServerVar('srpg_RecoverWeapons')) and players[steamid]['RecoverWeapons']:
            i = ev['item']
            u = ev['userid']
            c = Command(u).UpdateDict
            if i not in ['glock','usp']:
                if i in ['nvgs','vesthelm','vest','flashbang','hegrenade','smokegrenade']:
                    if i == 'nvgs': 
                        c('RecoverNvgs', 1)
                    elif i == 'vesthelm': 
                        c('RecoverVestHelm', 1)
                    elif i == 'vest': 
                        c('RecoverVest', 1)
                    elif i == 'flashbang':
                        Command(u).ModDict('RecoverFlashbang', 1)
                    elif i == 'hegrenade': 
                        c('RecoverHe', 1)
                    else: 
                        c('RecoverSmoke', 1)
                elif i in pistols and players[steamid]['RecoverWeapons'] > 1:
                    c('RecoverSecondary','weapon_%s'%i)
                elif i in rifles and players[steamid]['RecoverWeapons'] > 2:
                    c('RecoverPrimary','weapon_%s'%i)

'''
The following LongJump code was made by SumGuy14
and Murphey. I thank them for it, and do not take
any credit for this skill myself. They are excellent
coders!
'''

def player_jump(ev):
    """
    Whenever a player jumps, get the velocity of the jump at start position,
    and then end... Create a vector between them, then 'Multiply' the vector
    so it will increase the speed in which he's pulled.
    """
    if int(es.ServerVar('srpg_LongJump')):
        steamid = ReturnSteam(ev['userid'])
        if players[steamid]['LongJump']:
            vec1 = es.getplayerprop(ev['userid'],'CCSPlayer.baseclass.localdata.m_vecVelocity[0]')
            vec2 = es.getplayerprop(ev['userid'],'CCSPlayer.baseclass.localdata.m_vecVelocity[1]')
            vec1 = (players[steamid]['LongJump']*vec1)*(1/4.1)
            vec2 = (players[steamid]['LongJump']*vec2)*(1/4.1)
            vector = es.createvectorstring(vec1,vec2,0)
            es.setplayerprop(ev['userid'],'CCSPlayer.baseclass.localdata.m_vecBaseVelocity',vector)

'''
This smog skill was coded by the excellent
SuperDave. I had a go at myself, and went
a bit wrong, so he was kind enough to code
it for me!
'''

def smokegrenade_detonate(ev):
    """
    When a smoke grenade detonates, and the user has a SmogNade level,
    attach the usersID as the smokegrenades 'owner' then set it's
    ID inside a dictionary. 
    """
    global smokedict
    if int(es.ServerVar('srpg_SmogNade')):
        steamid = ReturnSteam(ev['userid'])
        if players[steamid]['SmogNade']:
            smokeplayer = int(ev['userid'])
            handle      = es.getplayerhandle(smokeplayer)
            for entity in es.createentitylist("smokegrenade_projectile"):
                if handle == es.getindexprop(entity,'CBaseEntity.m_hOwnerEntity'):
                    smokedict[entity] = smokeplayer
                    gamethread.delayed(18,removesmog,entity)
                    
def sg_update():
    """
    Checks to see if the Smoke Grenade still exists... If so,
    then remove the damage area. Also, will check to see if any enemys
    are within the range of smoke, if so, then damage them.
    """
    global smokedict
    if int(es.ServerVar('srpg_SmogNade')):
        smokelist = es.createentitylist("smokegrenade_projectile")
        for entity in smokedict.keys():
            if smokelist.has_key(entity):
                EntLoc = es.splitvectorstring(es.getindexprop(entity, 'CBaseEntity.m_vecOrigin'))
                player = smokedict[entity]
                for loop_player in playerlib.getPlayerList('#t,#alive' if int(es.getplayerteam(player)) == 3 else '#ct,#alive'):
                    location = loop_player.get('location')
                    if abs(EntLoc[0] - location[0]) <= 220 and abs(EntLoc[1] - location[1]) <= 220 and abs(EntLoc[2] - location[2]) <= 220:
                        es.server.queuecmd('damage %s %s 32 %s' % (int(loop_player), players[ReturnSteam(player)]['SmogNade'], player))
                        str_int = random.randint(1,3)
                        es.emitsound('player',int(loop_player),'player/damage%s.wav'%str_int,'0.7','0.6')
            else:
                del smokedict[entity]
        gamethread.delayedname(1,'SmokeUpdate',sg_update)

def removesmog(smogentity):
    """
    Will remove the smoke Grenade entity after 18 seconds.
    """
    entitylist = es.createentitylist("smokegrenade_projectile")
    if smogentity in entitylist:
        es.server.cmd('es_xremove %s'%smogentity)
    del entitylist 

def extinguish(uid):
    """
    Extinguish a person that's on fire. Turn the entities of
    who the fire is attatcher to, and the lifetime to 0
    """
    if int(es.ServerVar('srpg_NapalmNade')):
        napalmlist = es.createentitylist("entityflame")
        handle = es.getplayerhandle(uid)
        for a in napalmlist:
            string = es.getindexprop(a,'CEntityFlame.m_hEntAttached')
            if string == handle:
                es.setindexprop(a,'CEntityFlame.m_flLifetime',0)
                break
        del napalmlist

def AddXp(userid,steamid,amount,reason,message=True):
    """
    A function to Add XP to the user, then will check
    to see if the user has gained a level. If so, then
    check to see if the popup state is active. If so then
    send the popup. If the user is a bot, then do Bot Functin
    (see below)
    """
    global players
    global tokens
    xp = players[steamid]['Xp']
    level = players[steamid]['Level']
    credits = players[steamid]['Credits']
    if message and int(es.ServerVar('srpg_AnnounceXP')) and userid and int(userid):
        tokens = {'name':es.getplayername(userid),'amount':amount,'reason':reason,'prefix':es.ServerVar('srpg_Prefix')}
        es.tell(userid,'#multi',text('xp gained',tokens,playerlib.getPlayer(userid).get('lang')))
    xp += amount
    nextlevelxp = (level - 1) * int(es.ServerVar('srpg_XpIncrement')) + int(es.ServerVar('srpg_StartXP'))
    amountoflevels = 0
    while xp >= nextlevelxp:
        xp -= nextlevelxp
        amountoflevels += 1
        nextlevelxp += int(es.ServerVar('srpg_XpIncrement'))
    if amountoflevels:
        level += amountoflevels
        if not int(es.ServerVar('srpg_MaxLevel')) or level <= int(es.ServerVar('srpg_MaxLevel')):
            credits += amountoflevels * int(es.ServerVar('srpg_CreditIncrement'))
            players[steamid]['Level'] = level
            players[steamid]['Credits'] = credits
            if userid and int(userid) and not es.getplayerprop(userid,'CCSPlayer.baseclass.pl.deadflag'):
                location = es.getplayerlocation(userid)
                es.server.queuecmd('est_effect 10 #a 0 "sprites/steam1.vmt" %s %s %s 20 50 3 20 5 2 255 200 0 200 1'%(location[0],location[1],location[2]))
            if userid and int(userid) and es.ServerVar('srpg_LevelUpSound'):
                es.emitsound('player',userid,es.ServerVar('srpg_LevelUpSound'),'0.7','0.5')
            if userid and int(userid) and "BOT" not in steamid and players[steamid]['popup']:
                CreateSkillMenu(userid,steamid)
                skillmenu = 'skill_%s'%userid
                popuplib.send(skillmenu,userid)
            elif "BOT" in steamid:
                if int(es.ServerVar('srpg_BotMaxLevel')):
                    if level > int(es.ServerVar('srpg_BotMaxLevel')):
                        ResetSkills(userid if es.exists('userid',userid) else steamid,None,None)
                        return
                if es.exists('userid',userid):
                    BotLevelUp(userid,steamid,credits)
            if int(es.ServerVar('srpg_LevelUp')):
                if es.exists('userid',userid):
                    tokens = {'name':es.getplayername(userid),'level':level,'xp':xp,'nextxp':nextlevelxp,'prefix':es.ServerVar('srpg_Prefix')}
                    for userid in es.getUseridList():
                        es.tell(userid,'#multi',text('level gained global',tokens,playerlib.getPlayer(userid).get('lang')))
            elif es.exists('userid',userid):
                tokens = {'level':level,'xp':xp,'nextxp':nextlevelxp,'prefix':es.ServerVar('srpg_Prefix')}
                es.tell(userid,'#multi',text('level gained private', tokens, playerlib.getPlayer(userid).get('lang')))
        elif int(es.ServerVar('srpg_MaxLevelReset')) and int(es.ServerVar('srpg_MaxLevel')):
            if es.exists('userid',userid):
                ResetSkills(userid)
            else:
                ResetSkills(steamid)
    players[steamid]['Xp'] = xp
    
def BotLevelUp(u,s,c):
    """
    A function which randomly chooses a bots skill to level.
    If the bot has enough credits, then set that skill to the level. 
    """
    global players
    u = str(u)
    random_list = []
    for skill in ['Health','Regen','RegenAmmo','NapalmNade','Vampire','Stealth','LongJump','IceStab','FrostPistol','StunNade','SmogNade','Speed','Gravity','Disable','RecoverWeapons','RegenArmor','Medic','Adrenaline']:
        if int(es.ServerVar('srpg_%s'%skill)):
            level = players[s][skill]
            maxlevel = int(es.ServerVar('srpg_%sMax'%skill))
            if level < maxlevel:
                credits_needed = (level * int(es.ServerVar('srpg_%sCreditsIncrement'%skill)) + int(es.ServerVar('srpg_%sCreditsStart'%skill)))
                if c >= credits_needed:
                    random_list.append(skill)
    if not len(random_list): return
    skill = random.choice(random_list)
    level = players[s][skill] + 1
    credits_needed = (level * int(es.ServerVar('srpg_%sCreditsIncrement'%skill)) + int(es.ServerVar('srpg_%sCreditsStart'%skill)))
    c -= credits_needed
    players[s]['Credits'] = c
    players[s][skill] = level
    if skill == "Health":
        Command(u).HealthAdd(int(es.ServerVar('srpg_HealthIncrement')))
    elif skill == "Stealth":
        alpha = (255 - round((255/(int(es.ServerVar('srpg_StealthMax') + 1))) * players[s]['Stealth']))
        Command(u).Color(255, 255, 255, alpha)
    elif skill == "Speed":
        speed = 1 + (((float(es.ServerVar('srpg_SpeedMaxMovementSpeed')) - 1)/float(es.ServerVar('srpg_SpeedMax'))) * players[s]['Speed'])
        Command(u).Speed(speed)
    if es.ServerVar('srpg_SkillUpgradeSound'):
        es.emitsound('player',u,es.ServerVar('srpg_SkillUpgradeSound'),'0.7','0.5')
    BotLevelUp(u,s,c)
    
def CreateSkillMenu(userid,steamid):
    """
    THis function creates a specific popup just for that user.
    It contains his skills, and whether or not he can buy them.
    It will also calculate how much it will cost to buy each skill
    and show it.
    """
    p = 'skill_%s'%userid
    credits = players[steamid]['Credits']
    healthl = players[steamid]['Health']
    regenl = players[steamid]['Regen']
    regenammol = players[steamid]['RegenAmmo']
    firenadel = players[steamid]['NapalmNade']
    vampirel = players[steamid]['Vampire']
    stealthl = players[steamid]['Stealth']
    longjumpl = players[steamid]['LongJump']
    icestabl = players[steamid]['IceStab']
    frostpistoll = players[steamid]['FrostPistol']
    stunnadel = players[steamid]['StunNade']
    smognadel = players[steamid]['SmogNade']
    speedl = players[steamid]['Speed']
    gravityl = players[steamid]['Gravity']
    disablel = players[steamid]['Disable']
    recoverweaponsl = players[steamid]['RecoverWeapons']
    regenarmorl = players[steamid]['RegenArmor']
    adrenalinel = players[steamid]['Adrenaline']
    medicl = players[steamid]['Medic']
    a = popuplib.easymenu(p, '_popup_choice', UpgradeSkill)
    a.settitle('Please Select A Skill To Upgrade\n        Credits Available: %s\n               Page: '%credits)
    if int(es.ServerVar('srpg_Health')):
        if healthl < int(es.ServerVar('srpg_HealthMax')):
            a.addoption('Health','Health+ Lvl %s [Cost: %s]'%(healthl + 1, healthl * int(es.ServerVar('srpg_HealthCreditsIncrement')) + int(es.ServerVar('srpg_HealthCreditsStart'))))
        else:
            a.addoption('HealthMax','Health+ (MAX)',False)
    if int(es.ServerVar('srpg_Regen')):        
        if regenl < int(es.ServerVar('srpg_RegenMax')):
            a.addoption('Regen','Regeneration Lvl %s [Cost: %s]'%(regenl + 1, regenl * int(es.ServerVar('srpg_RegenCreditsIncrement')) + int(es.ServerVar('srpg_RegenCreditsStart'))))
        else:    
            a.addoption('RegenMax','Regeneration (MAX)',False)
    if int(es.ServerVar('srpg_RegenAmmo')):        
        if regenammol < int(es.ServerVar('srpg_RegenAmmoMax')):    
            a.addoption('RegenAmmo','Regenerate Ammo Lvl %s [Cost: %s]'%(regenammol + 1, regenammol * int(es.ServerVar('srpg_RegenAmmoCreditsIncrement')) + int(es.ServerVar('srpg_RegenAmmoCreditsStart'))))
        else:        
            a.addoption('Regenerate AmmoMax','Regenerate Ammo (MAX)',False)
    if int(es.ServerVar('srpg_NapalmNade')):        
        if firenadel < int(es.ServerVar('srpg_NapalmNadeMax')):    
            a.addoption('NapalmNade','Napalm Grenades Lvl %s [Cost: %s]'%(firenadel + 1, firenadel * int(es.ServerVar('srpg_NapalmNadeCreditsIncrement')) + int(es.ServerVar('srpg_NapalmNadeCreditsStart'))))
        else:
            a.addoption('Napalm GrenadeMax','Napalm Grenades (MAX)',False)
    if int(es.ServerVar('srpg_Vampire')):        
        if vampirel < int(es.ServerVar('srpg_VampireMax')):    
            a.addoption('Vampire','Vampire Lvl %s [Cost: %s]'%(vampirel + 1, vampirel * int(es.ServerVar('srpg_VampireCreditsIncrement')) + int(es.ServerVar('srpg_VampireCreditsStart'))))
        else:
            a.addoption('VampireMax','Vampire (MAX)',False)
    if int(es.ServerVar('srpg_Stealth')):        
        if stealthl < int(es.ServerVar('srpg_StealthMax')):    
            a.addoption('Stealth','Stealth Lvl %s [Cost: %s]'%(stealthl + 1, stealthl * int(es.ServerVar('srpg_StealthCreditsIncrement')) + int(es.ServerVar('srpg_StealthCreditsStart'))))
        else:
            a.addoption('StealthMax','Stealth (MAX)',False)
    if int(es.ServerVar('srpg_LongJump')):        
        if longjumpl < int(es.ServerVar('srpg_LongJumpMax')):    
            a.addoption('LongJump','Long Jump Lvl %s [Cost: %s]'%(longjumpl + 1, longjumpl * int(es.ServerVar('srpg_LongJumpCreditsIncrement')) + int(es.ServerVar('srpg_LongJumpCreditsStart'))))
        else:
            a.addoption('Long JumpMax','Long Jump (MAX)',False)
    if int(es.ServerVar('srpg_IceStab')):        
        if icestabl < int(es.ServerVar('srpg_IceStabMax')):    
            a.addoption('IceStab','Ice Stab Lvl %s [Cost: %s]'%(icestabl + 1, icestabl * int(es.ServerVar('srpg_IceStabCreditsIncrement')) + int(es.ServerVar('srpg_IceStabCreditsStart'))))
        else:
            a.addoption('Ice StabMax','Ice Stab (MAX)',False)
    if int(es.ServerVar('srpg_FrostPistol')):       
        if frostpistoll < int(es.ServerVar('srpg_FrostPistolMax')):    
            a.addoption('FrostPistol','Frost Pistol Lvl %s [Cost: %s]'%(frostpistoll + 1, frostpistoll * int(es.ServerVar('srpg_FrostPistolCreditsIncrement')) + int(es.ServerVar('srpg_FrostPistolCreditsStart'))))
        else:
            a.addoption('Frost PistolMax','Frost Pistol (MAX)',False)
    if int(es.ServerVar('srpg_StunNade')):        
        if stunnadel < int(es.ServerVar('srpg_StunNadeMax')):    
            a.addoption('StunNade','Stun Grenade Lvl %s [Cost: %s]'%(stunnadel + 1, stunnadel * int(es.ServerVar('srpg_StunNadeCreditsIncrement')) + int(es.ServerVar('srpg_StunNadeCreditsStart'))))
        else:
            a.addoption('Stun GrenadeMax','Stun Grenade (MAX)',False)
    if int(es.ServerVar('srpg_SmogNade')):        
        if smognadel < int(es.ServerVar('srpg_SmogNadeMax')):    
            a.addoption('SmogNade','Smog Grenade Lvl %s [Cost: %s]'%(smognadel + 1, smognadel * int(es.ServerVar('srpg_SmogNadeCreditsIncrement')) + int(es.ServerVar('srpg_SmogNadeCreditsStart'))))
        else:
            a.addoption('Smog GrenadeMax','Smog Grenade (MAX)',False)
    if int(es.ServerVar('srpg_Speed')):        
        if speedl < int(es.ServerVar('srpg_SpeedMax')):    
            a.addoption('Speed','Speed+ Lvl %s [Cost: %s]'%(speedl + 1, speedl * int(es.ServerVar('srpg_SpeedCreditsIncrement')) + int(es.ServerVar('srpg_SpeedCreditsStart'))))
        else:
            a.addoption('SpeedMax','Speed+ (MAX)',False)
    if int(es.ServerVar('srpg_Gravity')):        
        if gravityl < int(es.ServerVar('srpg_GravityMax')):    
            a.addoption('Gravity','Gravity- Lvl %s [Cost: %s]'%(gravityl + 1, gravityl * int(es.ServerVar('srpg_GravityCreditsIncrement')) + int(es.ServerVar('srpg_GravityCreditsStart'))))
        else:
            a.addoption('GravityMax','Gravity- (MAX)',False)
    if int(es.ServerVar('srpg_Disable')):        
        if disablel < int(es.ServerVar('srpg_DisableMax')):    
            a.addoption('Disable','Disable Lvl %s [Cost: %s]'%(disablel + 1, disablel * int(es.ServerVar('srpg_DisableCreditsIncrement')) + int(es.ServerVar('srpg_DisableCreditsStart'))))
        else:
            a.addoption('DisableMax','Disable (MAX)',False)
    if int(es.ServerVar('srpg_RecoverWeapons')):        
        if recoverweaponsl < int(es.ServerVar('srpg_RecoverWeaponsMax')):    
            a.addoption('RecoverWeapons','Recover Weapons Lvl %s [Cost: %s]'%(recoverweaponsl + 1, recoverweaponsl * int(es.ServerVar('srpg_RecoverWeaponsCreditsIncrement')) + int(es.ServerVar('srpg_RecoverWeaponsCreditsStart'))))
        else:
            a.addoption('Recover WeaponsMax','Recover Weapons (MAX)',False)
    if int(es.ServerVar('srpg_RegenArmor')):        
        if regenarmorl < int(es.ServerVar('srpg_RegenArmorMax')):
            a.addoption('RegenArmor','Regenerate Armor Lvl %s [Cost: %s]'%(regenarmorl + 1, regenarmorl * int(es.ServerVar('srpg_RegenArmorCreditsIncrement')) + int(es.ServerVar('srpg_RegenArmorCreditsStart'))))
        else:
            a.addoption('Regen ArmorMax','Regenerate Armor (MAX)',False)
    if int(es.ServerVar('srpg_Adrenaline')):        
        if adrenalinel < int(es.ServerVar('srpg_AdrenalineMax')):
            a.addoption('Adrenaline','Adrenaline Lvl %s [Cost: %s]'%(adrenalinel + 1, adrenalinel * int(es.ServerVar('srpg_AdrenalineCreditsIncrement')) + int(es.ServerVar('srpg_AdrenalineCreditsStart'))))
        else:
            a.addoption('AdrenalineMax','Adrenaline (MAX)',False)
    if int(es.ServerVar('srpg_Medic')):        
        if medicl < int(es.ServerVar('srpg_MedicMax')):
            a.addoption('Medic','Medic Lvl %s [Cost: %s]'%(medicl + 1, medicl * int(es.ServerVar('srpg_MedicCreditsIncrement')) + int(es.ServerVar('srpg_MedicCreditsStart'))))
        else:
            a.addoption('MedicMax','Medic (MAX)',False)
        
def UpgradeSkill(userid, choice, popupid):
    """
    This function is called when a user selects a skill
    to upgrade. It will check that 'Maximum' is not in the
    skill choice name... If it isn't, then it will calculate
    if the user has enough credits, and if he does, then deduct
    the credits it took to buy it away from his total credits,
    and add 1 to the skill
    """
    global players
    global tokens
    userid = str(userid)
    sid = ReturnSteam(userid)
    if not sid: return
    if 'Max' not in choice:
        if int(es.ServerVar('srpg_' + choice)):
            level = players[sid][choice] 
            if level < 0: level = 0
            ci = 'srpg_%sCreditsIncrement'%choice
            cs = 'srpg_%sCreditsStart'%choice
            credits = players[sid]['Credits']
            creditsrequired = level * int(es.ServerVar(ci)) + int(es.ServerVar(cs))
            if credits >= creditsrequired:
                level += 1
                credits -= creditsrequired
                players[sid][choice] = level
                players[sid]['Credits'] = credits
                if choice == "Regen": choice = "Regeneration"
                elif choice == "RegenAmmo": choice = "Regenerate Ammo"
                elif choice == "NapalmNade": choice = "Napalm Grenade"
                elif choice == "LongJump": choice = "Long Jump"
                elif choice == "IceStab": choice = "Ice Stab"
                elif choice == "FrostPistol": choice == "Frost Pistol"
                elif choice == "StunNade": choice == "Stun Grenade"
                elif choice == "SmogNade": choice == "Smog Grenade"
                elif choice == "RecoverWeapons": choice == "Recover Weapons"
                elif choice == "RegenArmor": choice == "Regenerate Armor"
                elif choice == "Health":
                    Command(userid).HealthAdd(int(es.ServerVar('srpg_HealthIncrement')))
                elif choice == "Stealth":
                    alpha = (255 - round((255/(int(es.ServerVar('srpg_StealthMax') + 1))) * players[sid]['Stealth']))
                    Command(userid).Color(255, 255, 255, alpha)
                elif choice == "Speed":
                    speed = 1 + (((float(es.ServerVar('srpg_SpeedMaxMovementSpeed')) - 1)/float(es.ServerVar('srpg_SpeedMax'))) * players[sid]['Speed'])
                    Command(userid).Speed(speed)
                if es.ServerVar('srpg_SkillUpgradeSound'):
                    es.emitsound('player',userid,es.ServerVar('srpg_SkillUpgradeSound'),'0.7','0.5')
                tokens = {'prefix':es.ServerVar('srpg_Prefix'),'level':level,'skill':choice}
                es.tell(userid,'#multi',text('skill upgrade',tokens,playerlib.getPlayer(userid).get('lang')))
            else:
                aoc = creditsrequired - credits
                tokens = {'credreq':creditsrequired,'amountofcred':aoc,'prefix':es.ServerVar('srpg_Prefix'),'credits':credits}
                es.tell(userid,'#multi',text('insufficient credits',tokens,playerlib.getPlayer(userid).get('lang')))
        else:
            tokens = {'skill':choice,'prefix':es.ServerVar('srpg_Prefix')}
            es.tell(userid,'#multi',text('disabled skill',tokens,playerlib.getPlayer(userid).get('lang')))
    CreateSkillMenu(userid,sid)
    skillmenu = 'skill_%s'%userid
    popuplib.send(skillmenu,userid) 

def CreateSellMenu(userid,steamid):
    """
    This Function is called when a user selects 'sell skills'
    on the rpgmenu, or types rpgsell. This will then show
    whether the user can sell the skill (incase he doesn't
    have a level), and tell him how much he can sell each skill
    for. It will also calculate the level the skill will go down
    to if he sells it.
    """
    p = 'sell_%s'%userid
    credits = players[steamid]['Credits']
    healthl = players[steamid]['Health']
    regenl = players[steamid]['Regen']
    regenammol = players[steamid]['RegenAmmo']
    firenadel = players[steamid]['NapalmNade']
    vampirel = players[steamid]['Vampire']
    stealthl = players[steamid]['Stealth']
    longjumpl = players[steamid]['LongJump']
    icestabl = players[steamid]['IceStab']
    frostpistoll = players[steamid]['FrostPistol']
    stunnadel = players[steamid]['StunNade']
    smognadel = players[steamid]['SmogNade']
    speedl = players[steamid]['Speed']
    gravityl = players[steamid]['Gravity']
    disablel = players[steamid]['Disable']
    recoverweaponsl = players[steamid]['RecoverWeapons']
    regenarmorl = players[steamid]['RegenArmor']
    adrenalinel = players[steamid]['Adrenaline']
    medicl = players[steamid]['Medic']
    
    a = popuplib.easymenu(p, '_popup_choice', DowngradeSkill)
    a.settitle('Please Select A Skill To Sell\n        Credits Available: %s\n        Sales Percentage: %s\n               Page: '%(credits,int(es.ServerVar('srpg_SellPercentage'))))
    if int(es.ServerVar('srpg_Health')):
        if healthl:
            a.addoption('Health','Health+ Lvl %s [Sell Price: %s]'%(healthl - 1, int((((healthl - 1) * int(es.ServerVar('srpg_HealthCreditsIncrement'))) + (int(es.ServerVar('srpg_HealthCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('HealthMax','Health+ - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_Regen')):
        if regenl:
            a.addoption('Regen','Regeneration Lvl %s [Sell Price: %s]'%(regenl - 1, int((((regenl - 1) * int(es.ServerVar('srpg_RegenCreditsIncrement'))) + (int(es.ServerVar('srpg_RegenCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:    
            a.addoption('RegenMax','Regeneration - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_RegenAmmo')):
        if regenammol:    
            a.addoption('RegenAmmo','Regenerate Ammo Lvl %s [Sell Price: %s]'%(regenammol - 1, int((((regenammol - 1) * int(es.ServerVar('srpg_RegenAmmoCreditsIncrement'))) + (int(es.ServerVar('srpg_RegenAmmoCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:        
            a.addoption('Regenerate AmmoMax','Regenerate Ammo - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_NapalmNade')):
        if firenadel:    
            a.addoption('NapalmNade','Napalm Grenades Lvl %s [Sell Price: %s]'%(firenadel - 1, int((((firenadel - 1) * int(es.ServerVar('srpg_NapalmNadeCreditsIncrement'))) + (int(es.ServerVar('srpg_NapalmNadeCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('Napalm GrenadeMax','Napalm Grenades - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_Vampire')):
        if vampirel:    
            a.addoption('Vampire','Vampire Lvl %s [Sell Price: %s]'%(vampirel - 1, int((((vampirel - 1) * int(es.ServerVar('srpg_VampireCreditsIncrement'))) + (int(es.ServerVar('srpg_VampireCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('VampireMax','Vampire - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_Stealth')):
        if stealthl:    
            a.addoption('Stealth','Stealth Lvl %s [Sell Price: %s]'%(stealthl - 1, int((((stealthl - 1) * int(es.ServerVar('srpg_StealthCreditsIncrement'))) + (int(es.ServerVar('srpg_StealthCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('StealthMax','Stealth - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_LongJump')):
        if longjumpl:    
            a.addoption('LongJump','Long Jump Lvl %s [Sell Price: %s]'%(longjumpl - 1, int((((longjumpl - 1) * int(es.ServerVar('srpg_LongJumpCreditsIncrement'))) + (int(es.ServerVar('srpg_LongJumpCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('Long JumpMax','Long Jump - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_IceStab')):
        if icestabl:    
            a.addoption('IceStab','Ice Stab Lvl %s [Sell Price: %s]'%(icestabl - 1, int((((icestabl - 1) * int(es.ServerVar('srpg_IceStabCreditsIncrement'))) + (int(es.ServerVar('srpg_IceStabCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('Ice StabMax','Ice Stab - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_FrostPistol')):
        if frostpistoll:    
            a.addoption('FrostPistol','Frost Pistol Lvl %s [Sell Price: %s]'%(frostpistoll - 1, int((((frostpistoll - 1) * int(es.ServerVar('srpg_FrostPistolCreditsIncrement'))) + (int(es.ServerVar('srpg_FrostPistolCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('Frost PistolMax','Frost Pistol - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_StunNade')):
        if stunnadel:    
            a.addoption('StunNade','Stun Grenade Lvl %s [Sell Price: %s]'%(stunnadel - 1, int((((stunnadel - 1) * int(es.ServerVar('srpg_StunNadeCreditsIncrement'))) + (int(es.ServerVar('srpg_StunNadeCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('Stun GrenadeMax','Stun Grenade - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_SmogNade')):
        if smognadel:    
            a.addoption('SmogNade','Smog Grenade Lvl %s [Sell Price: %s]'%(smognadel - 1, int((((smognadel - 1) * int(es.ServerVar('srpg_SmogNadeCreditsIncrement'))) + (int(es.ServerVar('srpg_SmogNadeCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('Smog GrenadeMax','Smog Grenade - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_Speed')):
        if speedl:    
            a.addoption('Speed','Speed+ Lvl %s [Sell Price: %s]'%(speedl - 1, int((((speedl - 1) * int(es.ServerVar('srpg_SpeedCreditsIncrement'))) + (int(es.ServerVar('srpg_SpeedCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('SpeedMax','Speed+ - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_Gravity')):
        if gravityl:    
            a.addoption('Gravity','Gravity- Lvl %s [Sell Price: %s]'%(gravityl - 1, int((((gravityl - 1) * int(es.ServerVar('srpg_GravityCreditsIncrement'))) + (int(es.ServerVar('srpg_GravityCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('GravityMax','Gravity- - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_Disable')):
        if disablel:    
            a.addoption('Disable','Disable Lvl %s [Sell Price: %s]'%(disablel - 1, int((((disablel - 1) * int(es.ServerVar('srpg_DisableCreditsIncrement'))) + (int(es.ServerVar('srpg_DisableCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('DisableMax','Disable - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_RecoverWeapons')):
        if recoverweaponsl:    
            a.addoption('RecoverWeapons','Recover Weapons Lvl %s [Sell Price: %s]'%(recoverweaponsl - 1, int((((recoverweaponsl - 1) * int(es.ServerVar('srpg_RecoverWeaponsCreditsIncrement'))) + (int(es.ServerVar('srpg_RecoverWeaponsCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('Recover WeaponsMax','Recover Weapons - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_RegenArmor')):
        if regenarmorl:    
            a.addoption('RegenArmor','Regenerate Armor Lvl %s [Sell Price: %s]'%(regenarmorl - 1, int((((regenarmorl - 1) * int(es.ServerVar('srpg_RegenArmorCreditsIncrement'))) + (int(es.ServerVar('srpg_RegenArmorCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('Regenerate ArmorMax','Regenerate Armor - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_Arenaline')):   
        if adrenalinel:    
            a.addoption('Adrenaline','Adrenaline Lvl %s [Sell Price: %s]'%(adrenalinel - 1, int((((adrenalinel - 1) * int(es.ServerVar('srpg_AdrenalineCreditsIncrement'))) + (int(es.ServerVar('srpg_AdrenalineCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('Adrenaline','Adrenaline - Need a Level to Sell',False)
    if int(es.ServerVar('srpg_Medic')): 
        if medicl:    
            a.addoption('Medic','Medic Lvl %s [Sell Price: %s]'%(medicl - 1, int((((medicl - 1) * int(es.ServerVar('srpg_MedicCreditsIncrement'))) + (int(es.ServerVar('srpg_MedicCreditsStart')))) * int(es.ServerVar('srpg_SellPercentage'))/100)))
        else:
            a.addoption('Medic','Medic - Need a Level to Sell',False)

def DowngradeSkill(userid, choice, popupid):
    """
    Will check to see if the user has at least level 1 in the skill,
    works out how much they will receive, then deduct a level and
    add the credits
    """
    global players, tokens
    userid = str(userid)
    sid = ReturnSteam(userid)
    if 'Max' not in choice:
        level = players[sid][choice] 
        ci = 'srpg_%sCreditsIncrement'%choice
        cs = 'srpg_%sCreditsStart'%choice
        ci = int(es.ServerVar(ci))
        cs = int(es.ServerVar(cs))
        per = int(es.ServerVar('srpg_SellPercentage'))
        credits = players[sid]['Credits']
        creditsgained = int((((level - 1) * ci) + cs) * per / 100)
        level -= 1
        credits += creditsgained
        players[sid][choice] = level
        players[sid]['Credits'] = credits
        if choice == "Regen": choice = "Regeneration"
        elif choice == "RegenAmmo": choice = "Regenerate Ammo"
        elif choice == "NapalmNade": choice = "Napalm Grenade"
        elif choice == "LongJump": choice = "Long Jump"
        elif choice == "IceStab": choice = "Ice Stab"
        elif choice == "FrostPistol": choice == "Frost Pistol"
        elif choice == "StunNade": choice == "Stun Grenade"
        elif choice == "SmogNade": choice == "Smog Grenade"
        elif choice == "RecoverWeapons": choice == "Recover Weapons"
        elif choice == "RegenArmor": choice == "Regenerate Armor"
        elif choice == "Health":
            Command(userid).HealthAdd(int(es.ServerVar('srpg_HealthIncrement')) * (-1))
        elif choice == "Stealth":
            alpha = (255 - round((255/(int(es.ServerVar('srpg_StealthMax') + 1))) * players[sid]['Stealth']))
            Command(userid).Color(255, 255, 255, alpha)
        elif choice == "Speed":
            speed = 1 + (((float(es.ServerVar('srpg_SpeedMaxMovementSpeed')) - 1)/float(es.ServerVar('srpg_SpeedMax'))) * players[sid]['Speed'])
            Command(userid).Speed(speed)
        if es.ServerVar('srpg_SkillDowngradeSound'):
            es.emitsound('player',userid,es.ServerVar('srpg_SkillDowngradeSound'),'0.7','0.5')
        tokens = {'prefix':es.ServerVar('srpg_Prefix'),'level':level,'skill':choice}
        es.tell(userid,'#multi',text('skill downgrade',tokens,playerlib.getPlayer(userid).get('lang')))
    CreateSellMenu(userid,sid)
    sellmenu = 'sell_%s'%userid
    popuplib.send(sellmenu, userid) 
                 
def IsEnabled(x):
    """
    Simple function to return whether or not the skill is enabled or disabled
    """
    if x: return '[Enabled]'
    else: return '[Disabled]'

def setup_auth():
    """
    Sets up an auth check service, to return whether or not the user is authed.
    """
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('sourcerpg_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'sourcerpg_admin')
    else:
        isAuthed = lambda x: False
      
def AdminAddXp():
    """
    Checks to see if the arguments are correct, then adds the xp to the user
    """
    if isAuthed(es.getcmduserid()):
        tempid = str(es.getargv(1))
        if tempid[0] in ['1','2','3','4','5','6','7','8','9']:
            uid = tempid
            sid = ReturnSteam(tempid)
        elif tempid.lower().startswith('steam_'):
            sid = tempid.replace('/',':')
            uid = None
        else:
            uid = str(es.getuserid(tempid))
            sid = ReturnSteam(uid)     
        amount = str(es.getargv(2))
        length = es.getargc()
        reason = ''
        if length > 3:
            index = 3
            while index <= es.getargc():
                reason = reason + ' ' + str(es.getargv(index))
                index += 1
        if int(amount[0]) in range(1,10):
            AddXp(uid, sid, int(amount), reason)
        else:
            es.tell(es.getcmduserid(),'#green',es.ServerVar('srpg_Prefix') + ' The correct syntax is: rpg_addxp <userid/name/steamid> <amount> [optional: reason]')
    else:
        es.tell(es.getcmduserid(),'#green','You are not authorised to run the \'rpg_addxp\' command!')
    
def AdminAddLevel():
    """
    Checks to see if the arguments are correct, then adds levels to the user.
    """
    global players, tokens
    if isAuthed(es.getcmduserid()):
        tempid = str(es.getargv(1))
        if tempid[0] in ['1','2','3','4','5','6','7','8','9']:
            uid = tempid
            sid = ReturnSteam(tempid)
        elif tempid.lower().startswith('steam_'):
            sid = tempid.replace('/',':')
            uid = None
        else:
            uid = str(es.getuserid(tempid))
            sid = ReturnSteam(uid)
        amount = str(es.getargv(2))
        if int(amount[0]) in range(1,10):
            level = players[sid]['Level']
            level += int(amount)
            if not int(es.ServerVar('srpg_MaxLevel')) or level <= int(es.ServerVar('srpg_MaxLevel')):
                credits = players[sid]['Credits']
                credits += int(amount) * int(es.ServerVar('srpg_CreditIncrement'))
                players[sid]['Credits'] = credits
                xp = players[sid]['Xp']
                nextlevelxp = (level - 1) * int(es.ServerVar('srpg_XpIncrement')) + int(es.ServerVar('srpg_StartXP'))
                players[sid]['Level'] = level
                if uid and not es.getplayerprop(uid,'CCSPlayer.baseclass.pl.deadflag'):
                    location = es.getplayerlocation(uid)
                    es.server.queuecmd('est_effect 10 #a 0 "sprites/steam1.vmt" %s %s %s 20 50 3 20 5 2 255 200 0 200 1'%(location[0],location[1],location[2]))
                    if es.ServerVar('srpg_LevelUpSound'):
                        es.emitsound('player',uid,es.ServerVar('srpg_LevelUpSound'),'0.7','0.5')
                if uid and "BOT" not in sid:
                    CreateSkillMenu(uid,sid)
                    skillmenu = 'skill_%s'%uid
                    popuplib.send(skillmenu,uid)
                else:
                    if es.exists('userid',uid):
                        BotLevelUp(uid,sid,credits)
                if uid and int(es.ServerVar('srpg_LevelUp')):
                    tokens = {'name':es.getplayername(uid),'level':level,'xp':xp,'nextxp':nextlevelxp,'prefix':es.ServerVar('srpg_Prefix')}
                    for userid in es.getUseridList():
                        es.tell(userid,'#multi',text('level gained global',tokens,playerlib.getPlayer(userid).get('lang')))
                elif uid:
                    tokens = {'level':level,'xp':xp,'nextxp':nextlevelxp,'prefix':es.ServerVar('srpg_Prefix')}
                    es.tell(uid,'#multi',text('level gained private', tokens, playerlib.getPlayer(uid).get('lang')))
            elif uid and int(es.ServerVar('srpg_MaxLevelReset')) and int(es.ServerVar('srpg_MaxLevel')):
                es.tell(uid, '#multi', text('maximum level reached', {'prefix':es.ServerVar('srpg_Prefix')}, playerlib.getPlayer(uid).get('lang')))
                ResetSkills(uid)
        else:
            es.tell(es.getcmduserid(),'#green',es.ServerVar('srpg_Prefix') + ' The correct syntax is: rpg_addlevel <userid/name/steamid> <amount>')
    else:
        es.tell(es.getcmduserid(),'#green','You are not authorised to run the \'rpg_addlevel\' command!')
        
def AdminAddCredit():
    """
    Checks to see if the args are correct, if so, then retrive the targets
    credits, adds the amount, then sets it
    """
    global players, tokens
    if isAuthed(es.getcmduserid()):
        tempid = str(es.getargv(1))
        if tempid[0] in ['1','2','3','4','5','6','7','8','9']:
            uid = tempid
            sid = ReturnSteam(tempid)
        elif tempid.lower().startswith('steam_'):
            sid = tempid.replace('/',':')
            uid = None
        else:
            uid = str(es.getuserid(tempid))
            sid = ReturnSteam(uid)  
        amount = str(es.getargv(2))
        length = es.getargc()
        reason = ''
        if length > 3:
            index = 3
            while index <= es.getargc():
                reason = reason + ' ' + str(es.getargv(index))
                index += 1
        if amount[0] in ['1','2','3','4','5','6','7','8','9']:
            credits = players[sid]['Credits']
            credits += int(amount)
            players[sid]['Credits'] = credits
            if uid:
                tokens = {'adminname':es.getplayername(es.getcmduserid()),'name':es.getplayername(uid),'creditsgave':amount,'prefix':es.ServerVar('srpg_Prefix'),'reason':reason}
                for uid in es.getUseridList():
                    es.tell(uid,'#multi',text('admin gave credits',tokens,playerlib.getPlayer(uid).get('lang')))
        else:
            es.tell(es.getcmduserid(),'#green',es.ServerVar('srpg_Prefix') + ' The correct syntax is: rpg_addcredits <userid/name/steamid> <amount> [optional: reason]')
    else:
        es.tell(es.getcmduserid(),'#green','You are not authorised to run the \'rpg_addcredits\' command!')

def SendSkillsMenuFromPopup(userid, choice, popupid):
    """
    This menu Creates a new Skills popup for the user
    """
    CreateSkillMenu(userid,ReturnSteam(userid))
    skillmenu = 'skill_%s'%userid
    popuplib.send(skillmenu,userid)
    
def SendSellMenuFromPopup(userid, choice, popupid):
    """
    This menu creates a new unique sell popup for the player
    """
    CreateSellMenu(userid,ReturnSteam(userid))
    sellmenu = 'sell_%s'%userid
    popuplib.send(sellmenu,userid)
    
def SendRank(steamid,name):
    """
    Sorted the dict out by level, then returns the index of the user.
    """
    global tokens
    a = sorted(players,SortRank)
    position = a.index(steamid) + 1
    totalranked = len(a)
    xp = players[steamid]['Xp']
    level = players[steamid]['Level']
    credits = players[steamid]['Credits']
    nextlevelxp = (level - 1) * int(es.ServerVar('srpg_XpIncrement')) + int(es.ServerVar('srpg_StartXP'))
    tokens = {'prefix':es.ServerVar('srpg_Prefix'),'name':name,'level':level,'rank':position,'total':totalranked,'xp':xp,'nextxp':nextlevelxp,'credits':credits}
    for a in es.getUseridList():
        es.tell(a,'#multi',text('rank',tokens,playerlib.getPlayer(a).get('lang')))

def SortRank(item1, item2):
    """
    Own function to sort out the dictionary into the highest levels
    """
    if players[item1]['Level'] > players[item2]['Level']: return -1
    if players[item1]['Level'] == players[item2]['Level']: return 0
    return 1
    
def BuildStatsMenu(userid, choice, popupid):
    """
    Builds a custom stats menu for the user
    """
    sid = ReturnSteam(userid)
    b = sorted(players,SortRank)
    position = b.index(sid) + 1
    total = len(b)
    nextlevelxp = (players[sid]['Level'] - 1) * int(es.ServerVar('srpg_XpIncrement')) + int(es.ServerVar('srpg_StartXP'))
    statsmenu = popuplib.create('stats_%s'%userid)
    a = statsmenu.addline
    a('=== SourceRPG Stats ===')
    a('-------------')
    a('Total Time: %.2f hours'%players[sid]['TotalTime'])
    a(' ')
    a('Level: %s'%players[sid]['Level'])
    a('XP: %s/%s'%(players[sid]['Xp'],nextlevelxp))
    a('XP Needed to Level: %s'%(nextlevelxp - players[sid]['Xp']))
    a('Rank: %s/%s'%(position,total))
    a(' ')
    a('-------------')
    a('9. Skill Stats')
    a('0. Back')
    statsmenu.select(9,SendSkillStats)
    statsmenu.submenu(10,'rpgmenu')
    statsmenu.send(userid)
    
def SendSkillStats(userid, choice, popupid):
    """
    This will get the levels of the users stats, and add them
    to a popup to display all the skills
    """
    p = popuplib.create('s_%s'%userid)
    a = p.addline
    s = ReturnSteam(userid)
    a('=== SourceRPG Skills ===')
    a('      Credits: %s'%players[s]['Credits'])
    a('-------------')
    a('Health+ - %s'%players[s]['Health'])
    a('Regeneration - %s'%players[s]['Regen'])
    a('Regenerate Ammo - %s'%players[s]['RegenAmmo'])
    a('Napalm Grenade - %s'%players[s]['NapalmNade'])
    a('Vampire - %s'%players[s]['Vampire'])
    a('Stealth - %s'%players[s]['Stealth'])
    a('Long Jump - %s'%players[s]['LongJump'])
    a('Ice Stab - %s'%players[s]['IceStab'])
    a('Frost Pistol - %s'%players[s]['FrostPistol'])
    a('Stun Grenade - %s'%players[s]['StunNade'])
    a('Smog Grenade - %s'%players[s]['SmogNade'])
    a('Speed+ - %s'%players[s]['Speed'])
    a('Gravity- - %s'%players[s]['Gravity'])
    a('Disable - %s'%players[s]['Disable'])
    a('Recover Weapons - %s'%players[s]['RecoverWeapons'])
    a('Regenerate Armor - %s'%players[s]['RegenArmor'])
    a('Adrenaline - %s'%players[s]['Adrenaline'])
    a('Medic - %s'%players[s]['Medic'])
    a('-------------')
    a('0. Back')
    p.select(10,BuildStatsMenu)
    p.send(userid)
    
def SendAdminMenu():
    '''Send the admin menu if the person is authed'''
    if isAuthed(es.getcmduserid()):
        popuplib.send('srpg_adminmenu',es.getcmduserid())
    else:
        es.tell(es.getcmduserid(),'#green','You are not authorized to run the command: rpg_admin')
    
def CheckDisableMenuPopup(userid, choice, popupid):
    '''Just a mini function to call another and pass the userid'''
    BuildEnableDisableMenu(userid)
    
def CheckDisableMenu():
    '''If the user is authed, then build the enable/disable menu'''
    uid = es.getcmduserid()
    if isAuthed(uid):
        BuildEnableDisableMenu(uid)
       
def BuildEnableDisableMenu(uid):
    '''This lists all the skills, then builds an easymenu popup to allow
    the admin to enable/disable them'''
    a = popuplib.easymenu('adminskills', '_popup_choice', EnableDisableSkill)
    a.settitle('Please Select A Skill To Activate or Deactivate\n               Page: ')
    b = a.addoption
    b('Health','Health+ %s'%IsEnabled(int(es.ServerVar('srpg_Health'))))
    b('Regen','Regeneration %s'%IsEnabled(int(es.ServerVar('srpg_Regen'))))
    b('RegenAmmo','Regenerate Ammo %s'%IsEnabled(int(es.ServerVar('srpg_RegenAmmo'))))
    b('NapalmNade','Napalm Grenade %s'%IsEnabled(int(es.ServerVar('srpg_NapalmNade'))))
    b('Vampire','Vampire %s'%IsEnabled(int(es.ServerVar('srpg_Vampire'))))
    b('Stealth','Stealth %s'%IsEnabled(int(es.ServerVar('srpg_Stealth'))))
    b('LongJump','Long Jump %s'%IsEnabled(int(es.ServerVar('srpg_LongJump'))))
    b('IceStab','Ice Stab %s'%IsEnabled(int(es.ServerVar('srpg_IceStab'))))
    b('FrostPistol','Frost Pistol %s'%IsEnabled(int(es.ServerVar('srpg_FrostPistol'))))
    b('StunNade','Stun Grenade %s'%IsEnabled(int(es.ServerVar('srpg_StunNade'))))
    b('SmogNade','Smog Grenade %s'%IsEnabled(int(es.ServerVar('srpg_SmogNade'))))
    b('Speed','Speed+ %s'%IsEnabled(int(es.ServerVar('srpg_Speed'))))
    b('Gravity','Gravity- %s'%IsEnabled(int(es.ServerVar('srpg_Gravity'))))
    b('Disable','Disable %s'%IsEnabled(int(es.ServerVar('srpg_Disable'))))
    b('RecoverWeapons','Recover Weapons %s'%IsEnabled(int(es.ServerVar('srpg_RecoverWeapons'))))
    b('RegenArmor','Regenerate Armor %s'%IsEnabled(int(es.ServerVar('srpg_RegenArmor'))))
    b('Adrenaline','Adrenaline %s'%IsEnabled(int(es.ServerVar('srpg_Adrenaline'))))
    b('Medic','Medic %s'%IsEnabled(int(es.ServerVar('srpg_Medic'))))
    a.send(uid)
        
def EnableDisableSkill(uid, choice, popupid):
    '''This toggels on/off the ability from a choice which came from a popup'''
    skill = 'srpg_%s'%choice
    if IsEnabled(int(es.ServerVar(skill))) == "[Enabled]":
        es.ServerVar(skill).set(0)
        es.tell(uid,'#green','The skill is now Deactivated.')
        BuildEnableDisableMenu(uid)
    else:
        es.ServerVar(skill).set(1)
        es.tell(uid,'#green','The skill is now Activated')
        BuildEnableDisableMenu(uid)
    
def CreateXpPlayerList(uid,choice,popupid):
    '''This just creates a player list using the popuplib function'''
    themenu = popuplib.easymenu('player_list', '_popup_choice', CreateXpInputBox)
    themenu.settitle('Select a player:')
    playerlist = playerlib.getPlayerList('#all')
    for player in playerlist:
        t_userid = int(player)
        t_name = player.get('name')
        themenu.addoption(t_userid, t_name)
    themenu.send(uid) 
    
def CreateXpInputBox(uid, choice, popupid):
    '''This just creates an escape input bopx to allow a user to input a value'''
    global tokens
    if str(choice).lower().startswith('steam_'):
        choice = str(choice).replace(':','/')
    es.escinputbox(30, uid, '=== SourceRPG Admin - Give Xp ===', 'Enter the XP Value', 'rpg_addxp %s'%choice)
    tokens = {'prefix':es.ServerVar('srpg_Prefix')}
    es.tell(uid,'#multi',text('escmenu',tokens,playerlib.getPlayer(uid).get('lang')))

def CreateLevelPlayerList(uid,choice,popupid):
    '''This just creates a player list using the popuplib function'''
    themenu = popuplib.easymenu('player_list', '_popup_choice', CreateLevelInputBox)
    themenu.settitle('Select a player:')
    playerlist = playerlib.getPlayerList('#all')
    for player in playerlist:
        t_userid = int(player)
        t_name = player.get('name')
        themenu.addoption(t_userid, t_name)
    themenu.send(uid) 

def CreateLevelInputBox(uid, choice, popupid):
    '''This just creates an escape input bopx to allow a user to input a value'''
    global tokens
    if str(choice).lower().startswith('steam_'):
        choice = str(choice).replace(':','/')
    es.escinputbox(30, uid, '=== SourceRPG Admin - Give Level ===', 'Enter the Level Value', 'rpg_addlevel %s'%choice)
    tokens = {'prefix':es.ServerVar('srpg_Prefix')}
    es.tell(uid,'#multi',text('escmenu',tokens,playerlib.getPlayer(uid).get('lang')))

def CreateCreditPlayerList(uid,choice,popupid):
    '''This just creates a player list using the popuplib function'''
    themenu = popuplib.easymenu('player_list', '_popup_choice', CreateCreditInputBox)
    themenu.settitle('Select a player:')
    playerlist = playerlib.getPlayerList('#all')
    for player in playerlist:
        t_userid = int(player)
        t_name = player.get('name')
        themenu.addoption(t_userid, t_name)
    themenu.send(uid) 

def CreateCreditInputBox(uid, choice, popupid):
    '''This just creates an escape input bopx to allow a user to input a value'''
    global tokens
    if str(choice).lower().startswith('steam_'):
        choice = str(choice).replace(':','/')
    es.escinputbox(30, uid, '=== SourceRPG Admin - Give Credits ===', 'Enter the Credits Value', 'rpg_addcredits %s'%choice)
    tokens = {'prefix':es.ServerVar('srpg_Prefix')}
    es.tell(uid,'#multi',text('escmenu',tokens,playerlib.getPlayer(uid).get('lang')))
    
def ResetSkills(userid=None, choice=None, popupid=None):
    '''This resets all the players skills and allows them to restart
    a fresh game.'''
    global players, tokens
    if str(userid).isdigit():
        uid = userid
        userid = ReturnSteam(uid)
        check = es.getuserid(userid)
        if check:
            tokens = {'prefix':es.ServerVar('srpg_Prefix')}
            uid = check
            es.tell(uid,'#multi',text('info deleted',tokens,playerlib.getPlayer(uid).get('lang')))
            es.sexec(uid,'kill')
            Command(uid).ResetDict()
            es.server.cmd('est_SetGravity %s 1.0'%uid)
            es.server.cmd('est_SetPlayerColor %s 255 255 255 255 1'%uid)
    del players[str(userid)]
    if es.exists('userid', es.getuserid(str(userid))):
        players[str(userid)] = {'Level':1,'Xp':0,'Credits':es.ServerVar('srpg_StartCredits'),'Regen':0,'Health':0,'RegenAmmo':0,'Stealth':0,'Vampire':0,'NapalmNade':0,'IceStab':0,'FrostPistol':0,'LongJump':0,'Speed':0,'Gravity':0,'StunNade':0,'SmogNade':0,'RecoverWeapons':0,'Disable':0,'RegenArmor':0,'TotalTime':0,'popup':int(es.ServerVar('srpg_StartPopupStatus')), 'Name': es.getplayername(es.getuserid(str(userid))), 'Adrenaline':0, 'Medic':0}
    start_time = time.time()
    
def DeleteDatabase(userid=None, choice=None, popupid=None):
    '''This will delete all the people in the database, and reset
    all the players starts then restart the game'''
    if isAuthed(userid) or not userid:
        tokens = {}
        tokens['prefix'] = str(es.ServerVar('srpg_Prefix'))
        if userid:
            tokens['admin'] = es.getplayername(userid)
        else:
            tokens['admin'] = 'Server'
        for player in playerlib.getPlayerList('#all'):
            es.sexec(int(player),'kill')
            es.tell(int(player), '#multi', text('deleteing database', tokens, player.get('lang')))
        players.clear()
        for a in es.getUseridList():
            a = str(a)
            steamid = ReturnSteam(a)
            es.server.queuecmd('est_SetGravity %s 1.0'%a)
            players[steamid] = {'Level':1,'Xp':0,'Credits':es.ServerVar('srpg_StartCredits'),'Regen':0,'Health':0,'RegenAmmo':0,'Stealth':0,'Vampire':0,'NapalmNade':0,'IceStab':0,'FrostPistol':0,'LongJump':0,'Speed':0,'Gravity':0,'StunNade':0,'SmogNade':0,'RecoverWeapons':0,'Disable':0,'TotalTime':0.0}
            popuplib.send('helpmenu',a)
            if not players[steamid].has_key('RegenArmor'): 
                players[steamid]['RegenArmor'] = 0
            if not players[steamid].has_key('popup'):
                players[steamid]['popup'] = int(es.ServerVar('srpg_StartPopupStatus'))
            if not players[steamid].has_key('Adrenaline'):
                players[steamid]['Adrenaline'] = 0
                players[steamid]['Medic'] = 0
            players[steamid]['LastConnected'] = datetime.date.today()
            players[steamid]['Name'] = es.getplayername(a)
        es.server.queue('mp_restartgame 1')
    
def BuildPeopleMenu(userid=None,choice=None, popupid=None):
    '''This builds a popup of all the players in the dictionary from
    all the people inside the dictionary'''
    ppopup = popuplib.easymenu('Players', '_popup_choice', DetailedOptionsSelect)
    ppopup.settitle('Please select a player to find out more info.')
    a = sorted(players, SortAlphabetically)
    for player in a:
        ppopup.addoption(player, players[player]['Name'])
    popuplib.send('Players',userid)
    
def SortAlphabetically(item1, item2):
    '''This will sort the dictionary so it is returned alphabetically'''
    if not players[item1].has_key('Name'): return -1
    if not players[item2].has_key('Name'): return -1
    if players[item1]['Name'] > players[item2]['Name']: return 1
    if players[item1]['Name'] == players[item2]['Name']: return 0
    return -1
    
def DetailedOptionsSelect(userid, choice, popupid):
    '''This popup is used to get more detail from a specific
    user inside the main dictionary. It will give options for
    the admin to do'''
    ppopup = popuplib.create('detailed_player')
    ppopup.addline('Detailed Specification')
    ppopup.addline('----------------------')
    ppopup.addline('Total Time: %.2f hours'%(players[choice]['TotalTime']))
    ppopup.addline(' ')
    ppopup.addline('Level: %s'%(players[choice]['Level']))
    ppopup.addline('XP: %s'%(players[choice]['Xp']))
    ppopup.addline('Credits: %s'%(players[choice]['Credits']))
    ppopup.addline(' ')
    ppopup.addline('->1. Delete %s'%players[choice]['Name'])
    ppopup.addline('->2. Give Xp')
    ppopup.addline('->3. Give Levels')
    ppopup.addline('->4. Give Credits')
    ppopup.addline('----------------------')
    ppopup.addline('0. Back')
    for x in range(1,5):
        ppopup.select(x,SendPopupMethods)
        ppopup.menuvalue('srpg_steamid',x,choice)
    for x in range(5,10):
        ppopup.submenu(x, 'detailed_player')
    ppopup.submenu(10,'Players')
    ppopup.send(userid)
    
def debugMsg(level, message):
    '''Sends a debug message to console. Cuts down on the amount of checks'''
    if int(es.ServerVar('srpg_DebugMode')) >= level:
        print message
    
command_dict = {}
class Command:
    "Class for all the commands"
    
    global command_dict
    def __init__(self, userid):
        '''
        This runs whenever Command(userid) is called.
        It initializes the class, and sets up the dict
        options for the user
        '''
        
        self.userid = int(userid)
        self.steamid = ReturnSteam(self.userid)
        if not command_dict.has_key(self.userid):
            command_dict[self.userid] = {}
            self.key = command_dict[self.userid]
            if players.has_key(self.steamid):
                self.key['MaxHealth'] = players[self.steamid]['Health'] * int(es.ServerVar('srpg_HealthIncrement')) + 100
                self.key['MaxSpeed'] = (1 + (((float(es.ServerVar('srpg_SpeedMaxMovementSpeed')) - 1)/float(es.ServerVar('srpg_SpeedMax'))) * players[self.steamid]['Speed']))
                self.key['MaxGrav'] = 1 - (((1.0/(int(es.ServerVar('srpg_GravityMax')))) - (float(es.ServerVar('srpg_GravityMinGravity'))/ int(es.ServerVar('srpg_GravityMax')))) * players[self.steamid]['Gravity'])
                self.key['MinAlpha'] =  255 - round(((255/(int(es.ServerVar('srpg_StealthMax')) + 1))) * players[self.steamid]['Stealth'])
            else:
                self.key['MaxHealth'] = 100
                self.key['MaxSpeed'] = 1
                self.key['MaxGrav'] = 1
                self.key['MinAlpha'] = 255
            self.key['AlreadyAdrenalined'] = 0
            self.key['Slowed'] = 0
            self.key['Weighed'] = 0
            self.key['RegenLoop'] = 0
            self.key['RegenAmmoLoop'] = 0
            self.key['RegenArmorLoop'] = 0
            
            debugMsg(2,'\nPlayers Dictionary Items:\n--------------------------------\n')
            for a in self.key:
                debugMsg(2,'%s - %s'%(a, self.key[a]))
            debugMsg(2,'--------------------------------\n')
            
        self.key = command_dict[self.userid]
            
    def ResetDict(self):
        '''
        This resets all the players dictionary items
        back to default settings
        '''
        
        if players.has_key(self.steamid):
            self.key['MaxHealth'] = players[self.steamid]['Health'] * int(es.ServerVar('srpg_HealthIncrement')) + 100
            self.key['MaxSpeed'] = (1 + (((float(es.ServerVar('srpg_SpeedMaxMovementSpeed')) - 1)/float(es.ServerVar('srpg_SpeedMax'))) * players[self.steamid]['Speed']))
            self.key['MaxGrav'] = 1 - (((1.0/(int(es.ServerVar('srpg_GravityMax')))) - (float(es.ServerVar('srpg_GravityMinGravity'))/ int(es.ServerVar('srpg_GravityMax')))) * players[self.steamid]['Gravity'])
            self.key['MinAlpha'] =  255 - (round((255/(int(es.ServerVar('srpg_StealthMax') + 1))) * players[self.steamid]['Stealth']))
        else:
            self.key['MaxHealth'] = 100
            self.key['MaxSpeed'] = 1
            self.key['MaxGrav'] = 1
            self.key['MinAlpha'] = 255
        self.key['AlreadyAdrenalined'] = 0
        self.key['Slowed'] = 0
        self.key['Weighed'] = 0
        self.key['RegenLoop'] = 0
        self.key['RegenAmmoLoop'] = 0
        self.key['RegenArmorLoop'] = 0
    
    def UpdateDict(self, key, amount):
        '''
        This command updates a players dictionary item
        to a new value
        '''
        
        self.key[key] = amount
        
    def ModDict(self, key, amount):
        '''
        This command modifies an existing value for an item
        in a players dictionary
        '''
        
        if self.key.has_key(key):
            self.key[key] += amount
        else:
            self.key[key] = amount
            
    def ResetRecover(self):
        '''
        Resets the Recover Items keys inside the players dictionary
        This is so that you do not rejoin with the same weapons.
        '''
        self.UpdateDict('RecoverActive', 0)
        self.UpdateDict('RecoverVest', 0)
        self.UpdateDict('RecoverNvgs', 0)
        self.UpdateDict('RecoverVestHelm', 0)
        self.UpdateDict('RecoverHe', 0)
        self.UpdateDict('RecoverSmoke', 0)
        self.UpdateDict('RecoverFlashbang', 0)
        self.UpdateDict('RecoverSecondary', 0)
        self.UpdateDict('RecoverPrimary', 0)
            
    def ReturnDict(self, key):
        '''
        This will return the value of the key inside the players
        dict
        '''
        if self.key.has_key(key):
            return self.key[key]
        return None
        
    def Color(self, r, g, b, a=None, time=None):
        '''
        This will change a players color, and can change the alpha.
        After X seconds it will change a players color back if 
        that argument is given.
        '''
        if not a:
            a = self.ReturnDict('MinAlpha')
        es.server.queuecmd('est_SetPlayerColor %s %s %s %s %s 1'%(self.userid, r, g, b, a))
        if time:
            gamethread.delayed(time, lambda x: es.server.queuecmd(x) if not self.IsDead() else None, 'est_SetPlayerColor %s %s %s %s %s 1' % (self.userid, 255, 255, 255, a) )
            
    def Heal(self, amount):
        '''
        Heals a players health... If there health is full, then check their
        armor.
        '''
        health = int(es.getplayerprop(self.userid, 'CBasePlayer.m_iHealth'))
        mhealth = self.ReturnDict('MaxHealth')
        if health + amount <= mhealth:
            if health + amount:
                es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', health + amount)
            else:
                es.sexec(self.userid, 'kill')
        else:
            if es.getgame() == "Counter-Strike: Source":
                es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', mhealth)
                amount -= (mhealth - health)
                armor = int(es.getplayerprop(self.userid, 'CCSPlayer.m_ArmorValue'))
                armor += amount
                if armor <= mhealth:
                    es.setplayerprop(self.userid, 'CCSPlayer.m_ArmorValue', armor)
                else:
                    es.setplayerprop(self.userid, 'CCSPlayer.m_ArmorValue', mhealth)
            else: 
                es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', mhealth)
        
    def HealthAdd(self, amount):
        '''
        Adds a value to the current value of the players health
        '''
        health = int(es.getplayerprop(self.userid,'CBasePlayer.m_iHealth'))
        health += amount
        if health > 0:
            self.key['MaxHealth'] += amount
            es.setplayerprop(self.userid,'CBasePlayer.m_iHealth',health)
        
    def Health(self, amount):
        '''
        Sets a new value to the players maximum health
        '''
        self.key['MaxHealth'] = amount
        es.setplayerprop(self.userid,'CBasePlayer.m_iHealth',amount)
        
    def SpeedAdd(self, amount):
        '''
        Adds an amount to the current value for the players speed
        '''
        debugMsg(1,'Currently doing the command to add speed')
        speed = self.ReturnDict('MaxSpeed')
        debugMsg(1,'Speed before the add: %s'%speed)
        speed += amount
        debugMsg(1,'Speed after the add: %s'%speed)
        if speed < 0: speed = 0 
        self.key['MaxSpeed'] = speed
        es.server.queuecmd('est_Speed %s %s'%(self.userid, speed))
        
    def Speed(self, amount):
        '''
        Sets a new value to the players current speed
        '''
        debugMsg(1,'Currently Doing the command to modify the speed')
        debugMsg(1,'Changing players %s speed to %s'%(self.userid, amount))
        self.key['MaxSpeed'] = amount
        es.server.queuecmd('est_Speed %s %s'%(self.userid, amount))
        debugMsg(1,'Speed has been set')
        
    def Slow(self, amount, time):
        '''
        Slow down a player by X amount for X seconds
        '''
        debugMsg(2,'Testing for the slow command')
        if not self.ReturnDict('Slowed'):
            debugMsg(1,'Player %s is not slowed'%self.userid)
            self.key['Slowed'] = 1
            speed = self.ReturnDict('MaxSpeed')
            debugMsg(1,'Players speed before the deduction: %s'%speed)
            speed -= amount
            debugMsg(1,'Players speed after the deduction: %s'%speed)
            self.key['MaxSpeed'] = speed
            es.server.queuecmd('est_Speed %s %s'%(self.userid, speed))
            speed += amount
            gamethread.delayed(time, self.UpdateDict, ('MaxSpeed', speed))
            gamethread.delayed(time, lambda x: es.server.queuecmd(x) if not self.IsDead() else None, 'est_Speed %s %s' % (self.userid, speed) )
            # gamethread.delayed(time, es.server.queuecmd, 'est_Speed %s %s'%(self.userid, speed))
            gamethread.delayed(time, self.UpdateDict, ('Slowed', 0) )
            debugMsg(1,'Out of slow')
            
    def SetGravity(self, amount):
        '''
        Set a new value for the players Gravity
        '''
        self.key['MaxGrav'] = amount
        es.server.queuecmd('est_SetGravity %s %s'%(self.userid, amount))
        
    def ChangeGravity(self, amount):
        '''
        Add a certain amount to the players gravity
        '''
        gravity = self.ReturnDict('MaxGrav')
        gravity += amount
        if gravity < 0: gravity = 0
        es.server.queuecmd('est_SetGravity %s %s'%(self.userid, gravity))
        self.key['MaxGrav'] = gravity
        
    def WeighDown(self, amount, time):
        '''
        Add a certain amount of gravity to the player for 
        x seconds
        '''
        if not self.ReturnKey('Weighed'):
            self.key['Weighed'] = 1
            gravity = self.ReturnDict('MaxGrav')
            gravity += amount
            self.key['MaxGrav'] = gravity
            es.server.queuecmd('est_SetGravity %s %s'%(self.userid, gravity))
            gravity += amount
            gamethread.delayed(time, self.UpdateDict, ('MaxGrav', gravity))
            gamethread.delayed(time, lambda x: es.server.queuecmd(x) if not self.IsDead() else None, 'est_SetGravity %s %s' % (self.userid, gravity) )
            gamethread.delayed(time, self.UpdateDict, ('Weighed', 0) )
            
    def Freeze(self, time):
        '''
        Freeze a player for X seconds
        '''
        es.server.queuecmd('est_freeze %s 1'%self.userid)
        es.emitsound('player', self.userid, 'physics/glass/glass_impact_bullet%s.wav'%random.randint(1,4), '1.0', '0.5')
        gamethread.delayed(time, lambda x: es.server.queuecmd(x) if not self.IsDead() else None, 'est_Freeze %s 0' %self.userid)
        
    def IsDead(self):
        '''
        Returns if the player is dead or not
        '''
        return int(es.getplayerprop(self.userid, 'CBasePlayer.pl.deadflag'))
        
    def Regen(self):
        '''
        Begins the regeneration loop for a player
        '''
        if not self.ReturnDict('RegenLoop'):
            self.UpdateDict('RegenLoop', 1)
            gamethread.delayed(int(es.ServerVar('srpg_RegenDelay')), self.RegenLoop)

    def RegenArmor(self):
        """
        Begins the regen armor loop for a player
        """
        if not self.ReturnDict('RegenArmorLoop'):
            self.UpdateDict('RegenArmorLoop', 1)
            gamethread.delayed(int(es.ServerVar('srpg_RegenArmorDelay')), self.RegenArmorLoop)
        
    def RegenAmmo(self):
        """
        Begins the regen ammo loop for a player
        """
        if not self.ReturnDict('RegenAmmoLoop'):
            self.UpdateDict('RegenAmmoLoop', 1)
            gamethread.delayed(int(es.ServerVar('srpg_RegenArmorDelay')), self.RegenAmmoLoop)
            
    def MedicLoop(self):
        """
        Creates a loop to run the Medic skill.
        Runs the AreaRegen loop
        """
        if es.exists('userid', self.userid):
            sid = ReturnSteam(self.userid)
            level = players[sid]['Medic']
            if level and int(es.ServerVar('srpg_Medic')) and not es.getplayerprop(self.userid, 'CBasePlayer.pl.deadflag'):
                amount = level * int(es.ServerVar('srpg_MedicHealingIncrement'))
                size = (level - 1) * int(es.ServerVar('srpg_MedicDistanceIncrement')) + int(es.ServerVar('srpg_MedicMinDistance'))
                self.AreaRegen(size, amount, '#ct' if int(es.getplayerteam(self.userid)) == 3 else '#t')
                gamethread.delayedname(int(es.ServerVar('srpg_MedicDelay')), 'medic_%s'%self.userid, self.MedicLoop)
            
    def RegenLoop(self):
        """
        Will create a loop to check if the user
        has a regen active... If it does, return
        the current health, plus the level of the
        regen level, then check if it's more than
        the max level. If so, set the health to 
        his max health, then stop the regen.
        """
        if es.exists('userid',self.userid):
            sid = ReturnSteam(self.userid)
            ramount = players[sid]['Regen']
            if ramount and self.ReturnDict('RegenLoop'):
                health = int(es.getplayerprop(self.userid,'CBasePlayer.m_iHealth'))
                health += ramount
                maxhealth = self.ReturnDict('MaxHealth')
                if health < maxhealth:
                    es.setplayerprop(self.userid,'CBasePlayer.m_iHealth',health)
                    gamethread.delayed(int(es.ServerVar('srpg_RegenDelay')),self.RegenLoop)
                else:
                    es.setplayerprop(self.userid,'CBasePlayer.m_iHealth', maxhealth)
                    self.UpdateDict('RegenLoop',0)
                
    def RegenAmmoLoop(self):
        """
        Creates a loop to retrieve the active weapon of the user
        and compare it against the default ammo variables taken
        from the server.cfg. 
        """
        if es.exists('userid',self.userid):
            sid = ReturnSteam(self.userid)
            ramount = players[sid]['RegenAmmo']
            if ramount and self.ReturnDict('RegenAmmoLoop'):   
                uid = playerlib.getPlayer(self.userid)
                gun = uid.attributes['weapon']
                if gun: gun = gun.replace("weapon_","")
                if gun in pistols:  
                    ammo = uid.get('ammo','secondary')
                    ammo += ramount
                    if ammo <= pistols[gun]:
                        uid.set('ammo',['secondary',ammo])
                        gamethread.delayed(int(es.ServerVar('srpg_RegenAmmoDelay')),self.RegenAmmoLoop)
                        return
                    else:
                        uid.set('ammo',['secondary',pistols[gun]])
                        self.UpdateDict('RegenAmmoLoop',0)
                elif gun in rifles:
                    ammo = uid.get('ammo','primary')
                    ammo += ramount
                    if ammo <= rifles[gun]:
                        uid.set('ammo',['primary',ammo])
                        gamethread.delayed(int(es.ServerVar('srpg_RegenAmmoDelay')),self.RegenAmmoLoop)
                        return
                    else:
                        uid.set('ammo',['primary',rifles[gun]])
                        self.UpdateDict('RegenAmmoLoop',0)
                        
    def RegenArmorLoop(self):
        """
        Create a repeat loop to restore the users armor. Retrieves the armor level,
        then compares it against the maximum health, then does the check to see if they
        are past that, if so, set it to maximum, else repeat the loop.
        """
        if es.exists('userid',self.userid) and int(es.ServerVar('srpg_RegenAmmo')):
            sid = ReturnSteam(self.userid)
            ramount = players[sid]['RegenArmor']
            if ramount and self.ReturnDict('RegenArmorLoop'):   
                armor = int(es.getplayerprop(self.userid,'CCSPlayer.m_ArmorValue'))
                armor += ramount
                maxarmor = self.ReturnDict('MaxHealth')
                if armor <= maxarmor:
                    es.setplayerprop(self.userid,'CCSPlayer.m_ArmorValue',armor)
                    gamethread.delayed(int(es.ServerVar('srpg_RegenArmorDelay')),self.RegenArmorLoop)
                else:
                    es.setplayerprop(self.userid,'CCSPlayer.m_ArmorValue',maxarmor)
                    self.UpdateDict('RegenArmorLoop',0)
                    
    def AreaRegen(self, area, amount, filt='#all'):
        """
        Regenerates an area... THe filter is the playerlib filter
        to test for playes within the area. Do a symple pythag
        distance check, then Heal all players inside that area.
        """
        if not es.getplayerprop(self.userid, 'CBasePlayer.pl.deadflag'):
            x,y,z = es.getplayerlocation(self.userid)
            for player in playerlib.getUseridList(filt):
                effect = 0
                if player != self.userid:
                    xx,yy,zz = es.getplayerlocation(player)
                    distance = ((x - xx) ** 2 + (y - yy) ** 2 + (z - zz) ** 2 ) ** 0.5
                    if distance <= area:
                        effect = 1
                        Command(player).Heal(amount)
                if effect and int(es.ServerVar('srpg_MedicEffects')):
                    x,y,z = es.getplayerlocation(self.userid)
                    es.server.queuecmd('est_effect 10 %s 0 "sprites/lgtning.vmt" %s %s %s %s 20 0.2 10 10 0 0 255 0 255 30'%(filt.replace('ct','c'),x,y,z, area))
                    es.server.queuecmd('est_effect 10 %s 0.2 "sprites/lgtning.vmt" %s %s %s %s 20 0.2 10 10 0 0 255 0 255 30'%(filt.replace('ct','c'),x,y,z, area))
    
def ReturnSteam(userid):
    '''This returns the steam of a player using uniqueid'''
    if es.exists('userid',userid):
        return playerlib.uniqueid(userid, True)
    return None
		
def ReturnLevel(userid, level):
    '''This returns the level of a player'''
    steamid = ReturnSteam(userid)
    if not steamid: 
        return None
    if players.has_key(steamid):
        if players[steamid].has_key('Level'):
            return players[steamid]['level']
    
"""
The following Conversion tool was made by the excellent JoeyT2008
(Jordan Thomas). He is an excellent coder, and I take no credit
for this!
"""
    
class ReadSql:
    "Class to read the SQL Database from cssrpg.db"
    def __init__(self, db):
        self.db = db
        if not os.path.exists(db):
            return None
        self.connection = None
    def open(self):
        """
        Open the connection of the database with SQLite
        """
        self.connection = sqlite.connect(self.db)
        self.connection.text_factory = str
        self.cursor = self.connection.cursor()
    def close(self):
        """
        Close the connection of the database with SQLite
        """
        self.connection.close()
        self.connection = None
        self.cursor = None
    def readItems(self):
        """
        Read all items (skills) from the SQL Database
        """
        query = self.cursor.execute("SELECT * FROM items")
        return query.fetchall()
    def readPlayers(self):
        """
        Read a specific player's stats, including levels,
        xp annd credits etc.
        """
        query = self.cursor.execute("SELECT * FROM players")
        return query.fetchall()
    
def convertEntries(db):
    """
    This method converts all of the cssrpg's Database items over to the cPickle
    syntax, and all of SourceRPG's variable names.
    """
    rpgPlayers = {}
    itemID = {}
    rpgName = {0: "Speed", 1: "Gravity", 2: "StunNade", 3: "SmogNade", 4: "Disable", 5: "TotalTime"}
    f = ReadSql(db)
    f.open()
    players = f.readPlayers()
    items = f.readItems()
    f.close()
    for x in range(len(players)):
        steamid = str(players[x][2])
        if steamid == "BOT":
            steamid = "BOT_%s"%(players[x][1])
        rpgPlayers[steamid] = {}
        rpgPlayers[steamid]["Name"] = players[x][1]
        rpgPlayers[steamid]["Level"] = players[x][3]
        rpgPlayers[steamid]["Xp"] = players[x][4]
        rpgPlayers[steamid]["Credits"] = players[x][5]
        itemID[players[x][8]] = steamid
    for x in range(len(items)):
        if items[x][0] in itemID:
            steamid = itemID[items[x][0]]
            rpgPlayers[steamid]["Regen"] = items[x][1]
            rpgPlayers[steamid]["Health"] = items[x][2]
            rpgPlayers[steamid]["RegenAmmo"] = items[x][3]
            rpgPlayers[steamid]["Vampire"] = items[x][4]
            rpgPlayers[steamid]["Stealth"] = items[x][5]
            rpgPlayers[steamid]["LongJump"] = items[x][6]
            rpgPlayers[steamid]["NapalmNade"] = items[x][7]
            rpgPlayers[steamid]["IceStab"] = items[x][8]
            rpgPlayers[steamid]["FrostPistol"] = items[x][9]
            rpgPlayers[steamid]["Adrenaline"] = items[x][10]
            rpgPlayers[steamid]["RecoverWeapons"] = items[x][11]
            rpgPlayers[steamid]["Medic"] = items[x][12]
    for x in rpgPlayers:
        if len(rpgPlayers[x]) == 16:
            for i in range(6):
                rpgPlayers[x][rpgName[i]] = 0
    return rpgPlayers
    
def writeEntries(str_path, playersdb):
    """
    This loops through the SQL Converted DB (which is now a dictionary),
    and checks it against the players.db... If the SteamID's are different,
    then that SteamID is appended to player.db, then at the end, remove the
    cssrpg.db, and write the players.db to disk
    """
    global players
    entries = convertEntries(str_path)
    minus = 0
    for player in playersdb:
        if int(es.ServerVar('srpg_ConverterOverwrite')):
            entries[player] = playersdb[player]
            minus += 1
        else:
            if not entries.has_key(player):
                entries[player] = playersdb[player]
                
    total = (len(entries) - minus)
     
    filepath = open(es.getAddonPath('sourcerpg') + '/players.db', 'w')
    cPickle.dump(entries, filepath)
    filepath.close()
    os.remove(str_path)
    
    str_path = es.getAddonPath('sourcerpg') + '/players.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        players = cPickle.load(file_users)
        file_users.close()
        
    debugMsg(0,"SourceRPG: Converted and inserted %d entries!" % total)
    debugMsg(0,"SourceRPG: Conversion tool made by JoeyT2008")
    
def ConvertDatabase(str_path):
    global sqlite
    from pysqlite2 import dbapi2 as sqlite
    writeEntries(str_path, players)
    
#######################
#### END OF SCRIPT ####
#######################
